SystemOrganization addCategory: #'RPackage-Tests'!
SystemOrganization addCategory: #'SUnit-UI'!
SystemOrganization addCategory: #'SUnit-UI'!
SystemOrganization addCategory: #'Refactoring-Changes'!

ProtoObject subclass: #TestCoverage
	instanceVariableNames: 'hasRun reference method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!TestCoverage commentStamp: 'LaurentLaffont 4/15/2011 20:19' prior: 0!
I wrap a method in order to detect whether it has been called or not. Then I can be used to calculate test coverage for SUnit.!

!TestCoverage class methodsFor: 'instance creation' stamp: 'lr 3/30/2009 15:23'!
on: aMethodReference
	^ self new initializeOn: aMethodReference! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 20:26'!
doesNotUnderstand: aMessage
	^ method perform: aMessage selector withArguments: aMessage arguments! !

!TestCoverage methodsFor: 'private' stamp: 'StephaneDucasse 8/9/2011 17:51'!
flushCache
	self reference selector flushCache! !

!TestCoverage methodsFor: 'testing' stamp: 'lr 3/30/2009 15:09'!
hasRun
	^ hasRun! !

!TestCoverage methodsFor: 'initialization' stamp: 'lr 3/30/2009 15:19'!
initializeOn: aMethodReference
	hasRun := false.
	reference := aMethodReference.
	method := reference compiledMethod! !

!TestCoverage methodsFor: 'actions' stamp: 'StephaneDucasse 8/9/2011 17:51'!
install
	reference actualClass methodDictionary
		at: reference selector
		put: self! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 15:21'!
mark
	hasRun := true! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 15:27'!
reference
	^ reference! !

!TestCoverage methodsFor: 'evaluation' stamp: 'lr 3/30/2009 15:32'!
run: aSelector with: anArray in: aReceiver
	self mark; uninstall.
	^ aReceiver withArgs: anArray executeMethod: method! !

!TestCoverage methodsFor: 'actions' stamp: 'StephaneDucasse 8/9/2011 17:51'!
uninstall
	reference actualClass methodDictionary
		at: reference selector
		put: method! !

RPackage subclass: #MCMockRPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!MCMockRPackage commentStamp: 'cyrilledelaunay 1/24/2011 16:16' prior: 0!
This class should be used instead of MCMockPackageInfo in the monticello tests!

!MCMockRPackage class methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/3/2012 23:29'!
initialize
	[self packageOrganizerClass default registerPackage: self new ] on: MessageNotUnderstood do: []! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classNames
	^ #(	MCMockClassA
		 	MCMockASubclass
			MCMockClassB
			MCMockClassD
			MCMockClassE
			MCMockClassF
			MCMockClassG
			MCMockClassH
			MCMockClassI
		)! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classes
	^ self classNames select: [ :tmpName | Smalltalk globals hasClassNamed: tmpName ] thenCollect: [ :tmpName | Smalltalk globals at: tmpName ]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesClass: aClass
	^self classes includes: aClass! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesSystemCategory: categoryName
	^self systemCategories anySatisfy: [:cat | cat sameAs: categoryName]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:50:00+01:00'!
name

	^ self packageName! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
packageName
	^ 'MonticelloMocks'! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 7/4/2012 21:07'!
systemCategories
	^ Array with: 'MonticelloMocks'! !

TestCase subclass: #RPackageTestCase
	instanceVariableNames: 'oldMCAnnouncer announcerForTest oldPrivateAnnouncer privateAnnouncerForTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

RPackageTestCase subclass: #RPackageImportFromPackageInfoTest
	instanceVariableNames: 'emptyOrganizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:01'!
XPackageName

	^ #X! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:01'!
XSubcategoryName

	^ 'X-Subcategory'! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:12'!
classInXSubcategoryName

	^#ClassInXSubcategory! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'PavelKrivanek 7/18/2012 12:51'!
cleanClassesPackagesAndCategories

	|mCPackage|
	Smalltalk globals removeClassNamed: self classInXSubcategoryName.
	Smalltalk organization removeCategory: self XPackageName asString.
	Smalltalk organization removeCategory: self XSubcategoryName.
	mCPackage := self allManagers 
							detect: [:each | each packageName = self XPackageName] 
							ifNone: [nil].
	PackageOrganizer default unregisterPackage: (PackageOrganizer default packagesDictionary at: self XPackageName).
	mCPackage ifNotNil: [mCPackage unregister].
			! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createMethodNamed: methodName inClass: aClass inCategory: aCategoryName 

	^ aClass compile: (methodName, ' ^nil') classified: aCategoryName.! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createNewClassNamed: aName inCategory: aCategoryName
	
	| cls |
	cls := Object subclass: aName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategoryName.
	^ cls! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'PavelKrivanek 7/18/2012 12:55'!
createNewMCPackageNamed: aSymbol

	PackageInfo registerPackageName: aSymbol.
	MCWorkingCopy forPackage: (MCPackage new name: aSymbol)! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createNewTraitNamed: aName inCategory: aCategoryName
	
	| trait |
	trait := Trait named: aName asSymbol
			uses: {}
			category: aCategoryName.
	^ trait! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:02'!
createXPackage

	self createNewMCPackageNamed: self XPackageName! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:03'!
createXSubCategory

	Smalltalk globals organization addCategory: self XSubcategoryName.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:15'!
createXSubCategoryClass

	^ self createNewClassNamed:  self classInXSubcategoryName inCategory:  self XSubcategoryName.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/18/2011 13:50'!
emptyOrganizer

	^ emptyOrganizer! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setUp 
	super setUp.
	emptyOrganizer := self packageOrganizerClass new debuggingName: 'RPackageImportsFromPackageInfo Package Organizer'.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'GuillermoPolito 4/27/2012 13:27'!
tearDown
	self cleanClassesPackagesAndCategories.
	super tearDown.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:02'!
testImportExtensionFromParentPackageRegisterExtensionInParentPackage

	"
	When importing from PackageInfo :
	test that when a package extend a class from a sub-category of this package, the extension method is well registered as extension method of this package "
	"self run: #testImportExtensionFromParentPackageRegisterExtensionInParentPackage"
	|tmpClass XPackage|
	[self createXPackage.
	self createXSubCategory.
	tmpClass := self createXSubCategoryClass.
	self createMethodNamed:  #stubMethod inClass: tmpClass inCategory: '*',self XPackageName asString.
	self emptyOrganizer importFromPackageInfo: (PackageOrganizer default packagesDictionary at: self XPackageName asString).
	self emptyOrganizer importFromPackageInfo: (PackageOrganizer default packagesDictionary at: self XSubcategoryName).
	XPackage := self emptyOrganizer packageNamed: self XPackageName.
	"this test does not work because we have two different organizers: one from emptyOrganizer and one reached by the propagation of event"
	"self assert: ((tmpClass>>#stubMethod) packageFromOrganizer: self emptyOrganizer)  = XPackage."
	self assert: (XPackage includesExtensionSelector:  #stubMethod ofClass: tmpClass).   
	] 

	ensure: [
		emptyOrganizer = nil
	] 	   ! !

RPackageTestCase subclass: #RPackageIncrementalTest
	instanceVariableNames: 'createdClasses createdPackages createdCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageIncrementalTest commentStamp: 'StephaneDucasse 5/15/2010 20:21' prior: 0!
The tests takes as fixture the following situation (which is constructed partially)
For tests that do not need to check the incremental construction.


P1 
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
P2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3  (was *P2*)!

RPackageIncrementalTest subclass: #RPackageCompleteSetupButForModificationTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageCompleteSetupButForModificationTest methodsFor: 'setup' stamp: '2010-11-26T09:22:00+01:00'!
setUp
	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3)

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:53:00+01:00'!
testAddMethod
	"self debug: #testAddMethod"
	
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	
	a1 compileSilently: 'zork ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#zork).
	self assert: (p1 includesSelector: #zork ofClass: a1).
	
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:59:00+01:00'!
testBasicRemoveClass
	"we remove a class we check that it is not in the package anymore"
	"self debug: #testBasicRemoveClass"	

	|  size |
	size := p1 definedClasses size. 
	self assert: size = 2.
	self assert: (p1 includesClass: a1).
	self assert: (p1 includesClass: a1 class).
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = (size - 1).
	self assert: (p1 includesClass: b1).
	self assert: (p1 includesClass: b1 class).
	self deny: (p1 includesClass: a1).
	self deny: (p1 includesClass: a1 class).
	p1 removeClassDefinition: b1.
	self assert: p1 definedClasses size = (size - 2).
	self deny: (p1 includesClass: b1).
	self deny: (p1 includesClass: b1 class).

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-24T22:31:00+01:00'!
testExtensionMethodOfClass
	"self debug: #testExtensionMethodOfClass"
	
	"P1 
		A1DefinedInP1>>methodDefinedInP1
		B1DefinedInP1	
		A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
	P2
		A2DefinedInP2>>methodDefinedInP2
		B2DefinedInB2	

	P3
		A3DefinedInP3	
		A2DefinedInP2>>methodDefinedInP3  (was *P2*)"
		
	self assert: a2 methodDict keys size = 3.
	"the class contains methods defined by several packages 
	however when looking with a package view we only see the package 
	extension."
		
	self assert: (p2 extensionMethodsForClass: a2) size = 0.
	self assert: (p1 extensionMethodsForClass: a1) size = 0.
	"show that extensionMethodsForClass: does works for methods of class
	defined in the package"
	
	self assert: (p1 extensionMethodsForClass: a2) size = 1.
	self assert: (p3 extensionMethodsForClass: a2) size = 1.! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveMethod
	"self debug: #testRemoveMethod"
	
	p1 removeMethod: a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:27:00+01:00'!
testRemoveMethodDoesNotRemoveFromClass
	"we remove a method so it is not in the package but also not from the class anymore"
	"self debug: #testRemoveMethodDoesNotRemoveFromClass"
	
	p1 removeMethod:  a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (a1 selectors includes: #methodDefinedInP1)! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveShouldRaiseErrorWhenMethodIsNotInPackage
	"self debug: #testRemoveShouldRaiseErrorWhenMethodIsNotInPackage"
	
	self should: [p2 removeMethod: a2>>#methodDefinedZork] raise: Error! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-22T07:52:00+01:00'!
testStartingSituation
	"self debug: #testStartingSituation"
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T15:41:00+01:00'!
createNewClassNamed: aName
	^ self createNewClassNamed: aName inCategory: 'RPackageTest'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:16:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	createdCategories add: cat.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-03-11T13:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'EstebanLorenzano 7/27/2012 19:53'!
createNewPackageNamed: aName

	| pack |
	self removePackage: aName.
	pack := self packageClass named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 5/9/2011 16:47'!
createNewTraitNamed: aName
	^ self createNewTraitNamed: aName inCategory: 'RPackageTest'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'cyrilledelaunay 5/10/2011 11:39'!
createNewTraitNamed: aName inCategory: cat
	
	| cls |
	cls := Trait named: aName
			uses: {}
			category: cat.
	createdClasses add: cls.
	createdCategories add: cat.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 5/9/2011 17:48'!
createNewTraitNamed: aName inPackage: p
	
	| cls |
	cls := self createNewTraitNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:18:00+01:00'!
p1Name
	^ 'RPackageTestP1'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p2Name
	^ 'RPackageTestP2'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p3Name
	^ 'RPackageTestP3'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T17:18:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol
	Smalltalk at: aClassNameSymbol asSymbol ifPresent: [:c| c removeFromSystem]! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 6/3/2012 22:46'!
removePackage: aName
	self packageClass organizer basicUnregisterPackageNamed: aName.
	! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: 'GuillermoPolito 4/27/2012 13:24'!
setUp
	super setUp.
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.
	createdCategories := Set new.
	Author fullName ifNil: [Author fullName: 'RPackage'].! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 22:46'!
tearDown
	
	| logging |
	createdPackages  do: [:each | self removePackage: each name].
	"just remove package from package organizer dictionary"
	
	createdPackages  do: [:each |
		|mCPackage|
		mCPackage := self allManagers 
							detect: [:mcPackage | mcPackage packageName = each packageName asString] 
							ifNone: [nil].
		mCPackage ifNotNil: [mCPackage unregister].
		each extendedClasses do: [ :extendedClass|
			self packageClass organizer
		 		unregisterExtendingPackage: each forClass: extendedClass.]].
	"all ***extending*** classes the packages are also unregistered from PackageOrganizer"									
	(createdClasses reject: [:c| c isObsolete]) do: [:cls| 
		"(RPackage organizer includesPackageBackPointerForClass: cls) 
			ifTrue: [cls package unregisterClass: cls.]. 
		when RPackageOrganizer was not looking at system event we had to do the commented actions"
		logging := false.
		cls removeFromSystem: logging.  
		"not logging so no event are raised"
		"but this also means that the consistency cannot be ensured by internal system announcer too."
		].					
	createdCategories do: [:each | 
		|mCPackage|
		SystemOrganization removeCategory: each.
		 ].
	super tearDown.! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethods
	"self debug: #testAddClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethodsAtMetaclassToo
	"self debug: #testAddClassAfterMethodsAtMetaclassToo"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 class compileSilently: 'newlyAddedToA1Class ^ #methodDefinedInP1'.
	p1 addMethod: (a1 class>>#newlyAddedToA1Class).
	self assert: (p1 includesSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassDefinitionNoDuplicate
	"self debug: #testAddClassDefinitionNoDuplicate"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: a1.
	"adding the same class does not do anything - luckily"
	self assert: p definedClasses size = 1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveMethod
	"self debug: #testAddRemoveMethod"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	"removeMethod by default removes from defined methods and not extension"
	p2 removeMethod: (a2>>#methodDefinedInP2).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeMethod: (a2>>#methodDefinedInP1).
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:46:00+01:00'!
testAddRemoveSelector
	"self debug: #testAddRemoveSelector"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofClassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofClassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofClassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveSelectorOfMetaclass
	"self debug: #testAddRemoveSelectorOfMetaclass"
	
	| p1 p2 p3 a2   a2Name a2class |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofMetaclassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofMetaclassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofMetaclassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testBogusClassAddition
	"self debug: #testBogusClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self should: [p addClassDefinitionName: a1 class name] raise: Error.
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassAddition
	"self debug: #testClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: a1 class)
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemoval
	"self debug: #testClassDefinitionRemoval"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: b1 class.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemovalName
	"self debug: #testClassDefinitionRemovalName"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	p addClassDefinitionName: b1 name.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	self should: [p removeClassDefinitionName: b1 class name] raise: Error.
	p removeClassDefinitionName: b1  name.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testClasses
	"self debug: #testClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 classes size = 2.
	self assert: p2 classes size = 2.! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testDefinedClassesAndDefinedClassNames
	"self debug: #testDefinedClassesAndDefinedClassNames"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p definedClasses  includes: a1).
	self assert: (p definedClassNames includes: a1 name).
	
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p definedClasses includes: b1).
	self assert: (p definedClassNames includes: b1 name).
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:38:00+01:00'!
testExtensionClassNames
	"self debug: #testExtensionClassNames"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2 name.
	
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extensionMethods size = 1.
	self assert: (p1 extendedClassNames includes: #A2InPackageP2).
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addSelector: #firstMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addSelector: #secondMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testExtensionClasses
	"self debug: #testExtensionClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 1.
	self assert: (p1 extendedClasses  includes: a2).
	self assert: p1 extendedClassNames size = 1.
	self assert: (p1 extendedClassNames  includes: a2 name).
	
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClasses  includes: b2 class).
	"extensionClasses returns or metaclasses while extensionClassNames returns class names (but not metaclass names)"

	self assert: p1 extendedClassNames size = 2.
	self assert: (p1 extendedClassNames  includes: b2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:45:00+01:00'!
testExtensionClassesWithCompiledMethod
	"self debug: #testExtensionClassesWithCompiledMethod"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: b2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extendedClasses size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addMethod: (b2>>#secondMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:13:00+01:00'!
testExtensionMethods
	"self debug: #testExtensionMethods"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionSelectors  size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compileSilently: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	self assert: p1 extensionSelectors  size = 2.
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-03-11T14:35:00+01:00'!
testIncludeClass
	"self debug: #testIncludeClass"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	
	self deny: (p1 includesClass: a2).
	p1 addMethod: (a2>>#methodPackagedInP1).
	self deny: (p1 includesClass: a2).
	"We should declare the class explictly. Adding a method does not declare
	the class as defined. The reason is that like that the client controls the granularity 
	and moment of class registration."
	
	p1 addClassDefinition: a2.
	self assert: (p1 includesClass: a2).
	self assert: (p1 includesClassNamed: a2 name).
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeClassMore
	"self debug: #testIncludeClassMore"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesClass: a2).
	self deny: (p1 includesClass: a2).
	self deny: (p3 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfClass
	"self debug: #testIncludeSelectorOfClass"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2 name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofClass: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfMetaClass
	"self debug: #testIncludeSelectorOfMetaClass"
	
	| p1 p2 p3 a2  a2class |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2class>>#methodDefinedInP2).
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2class>>#methodDefinedInP1).
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2class>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2class).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClass: a2class).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofMetaclassName: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2 name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClass: a2 class).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClass: a2).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: 'StephaneDucasse 4/24/2011 20:25'!
testIncludesMethodOfClassInPresenceOfOtherPackageExtensions
	"self debug: #testIncludesMethodOfClassInPresenceOfOtherPackageExtensions"
	
	| p1 p2 p3 a2  a2name |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2name := #A2InPackageP2.
	a2 := self createNewClassNamed: a2name inPackage: p2.
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
		
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:46:00+01:00'!
testIncludesOrTouches
	"self debug: #testIncludesOrTouches"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self deny: (p1 includesClass: a2).
	self assert: (p1 definesOrExtendsClass: a2).
	self assert: (p2 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-03-11T16:50:00+01:00'!
testMethodAddition
	"self debug: #testMethodAddition"

	| p1 a1 methodRef |
	p1 := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	a1 compileSilently: 'foo ^ 10'.
	p1 addMethod:  (a1>>#foo).
	self assert: (p1 includesSelector: #foo ofClass: a1).
	! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-04-25T17:33:00+01:00'!
testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt
	"self debug: #testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: a2 package = p2.
	p1 extensionMethods do: 
		[:each | self deny: each methodClass package = p1 ].
	"the package of a class which is extended inside a package p, is not p
	but the package where the class was defined"! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-03-11T16:46:00+01:00'!
testPackageOfClassForDefinedClasses
	"self debug: #testPackageOfClassForDefinedClasses"
	
	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPAckageP1 inPackage: p.
	b1 := self createNewClassNamed: #B1InPAckageP1 inPackage: p.

	self assert: a1 package = p.
	self assert: b1 package = p.
! !

!RPackageIncrementalTest methodsFor: 'test registration' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testPrivateClassRegisterUnregister
	"Verify that when we register a class, the package organizer register it."
	"self debug: #testPrivateClassRegisterUnregister"

	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPackageP1.
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independantly from addClassDefinition:"
		"No event should be raised."
	p registerClass: a1.
	self assert: (self packageClass organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClass: a1.
	self assert: (self packageClass organizer packageOf: a1) isDefault.
	
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independant from addClassDefinition:"
	p registerClassName: a1 name.
	self assert: (self packageClass organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClassName: a1 name.
	self assert: (self packageClass organizer packageOf: a1) isDefault
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testRemoveClassAfterMethods
	"self debug: #testRemoveClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	
	"now we add a new method to the class and the to the package: it is considered
	as defined"
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = 0.
	
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not defined anymore but an extension "
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testUniqueClassInDefinedClassesUsingAddClassDefinition
	"self debug: #testUniqueClassInDefinedClassesUsingAddClassDefinition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1 class.
	self assert: p definedClasses size = 1.

! !

RPackageIncrementalTest subclass: #RPackageObsoleteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 5/26/2012 15:49'!
testAnnouncementClassRemovedIsRaisedOnRemoveFromSystem
	"self debug: #testAnnouncementClassRemovedIsRaisedOnRemoveFromSystem"
	| notRun foo | 
	notRun := false.
	SystemAnnouncer announcer weak on: ClassRemoved do: [:ann | notRun := true].
	foo := self createNewClassNamed: #FooForTest2.
	self deny: notRun.
	foo removeFromSystem.
	self assert: notRun. ! !

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 7/27/2012 19:40'!
testMethodPackageFromObsoleteClass
	"self debug: #testMethodPackageFromObsoleteClass"
	
	| pack method foo | 
	[
	pack := self createNewPackageNamed: 'P1'.
	foo := self createNewClassNamed: #FooForTest inPackage: pack.
	foo compile: 'bar ^42'.
	method := foo>>#bar.

	foo obsolete.
	self assert: (method packageFromOrganizer: pack organizer) equals: foo package.
	] ensure: [ 
		foo ifNotNil: [ 
			foo setName: foo originalName.
			foo removeFromSystem.
			].
		Smalltalk globals removeKey: #FooForTest  ifAbsent:  [].
	]! !

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/29/2012 13:25'!
testMethodPackageOfRemovedClass
	"self debug: #testMethodPackageOfRemovedClass"
	
	| pack method foo | 
	pack := self createNewPackageNamed: 'P1'.
	foo := self createNewClassNamed: #FooForTest2 inPackage: pack.
	foo compileSilently: 'bar ^42'.
	method := foo>>#bar.
	foo removeFromSystem.
	self deny: (pack includesClassNamed: #FooForTest2 )
	
	! !

RPackageIncrementalTest subclass: #RPackageReadOnlyCompleteSetupTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2 p4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageReadOnlyCompleteSetupTest commentStamp: 'StephaneDucasse 4/13/2011 17:10' prior: 0!
The tests takes as fixture the following situation and exercises the readonly queries.
We should be able to use a test resources to speed it up.

P1 
	A1DefinedInP1
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1
	
P2
	A2DefinedInP2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3 !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'expectedfailures' stamp: '2010-04-20T21:50:00+01:00'!
expectedFailures

	^ #(testClassNamesAndExtensionSelectorsDo testClassNamesAndExtensionSelectorsDo testClassesAndExtensionMethodsDo testClassesAndExtensionMethodsDo)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:43'!
setUp

	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:24'!
testAddTag
	"self debug: #testAddTag"
	
	self assert: p1 tags isEmpty.
	p1 addClassTag: #baz. 
	self assert: (p1 tags includes: #baz).
	self assert: (p1 tags size = 1).
	
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: (p1 tags includes: #foo).
	self assert: (p1 tags size = 2).
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	p1 addClassTag: #foo. 
	self assert: (p1 tags includes: #baz).
	self assert: (p1 tags includes: #foo).
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/25/2011 23:42'!
testAddTagsToAClass
	"self debug: #testAddTagsToAClass"
	
	self assert: p1 tags isEmpty.
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).

	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #zork.
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	self assert: ((p1 classesForClassTag: #zork) size = 1).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: 'StephaneDucasse 4/13/2011 17:09'!
testClassIsExtendedInPackage
	"self debug: #testClassIsExtendedInPackage"
	
	self deny: ((Smalltalk globals at: #A1DefinedInP1) isExtendedInPackage: p1).
	self assert: (p1 includesClass: (Smalltalk globals at: #A1DefinedInP1)).
	self deny: (p1 extendsClass: (Smalltalk globals at: #A1DefinedInP1)).
	self assert: ((Smalltalk globals at: #A2DefinedInP2) isExtendedInPackage: p1).
	self deny: (p1 includesClass: (Smalltalk globals at: #A2DefinedInP2)).
	self assert: (p1 extendsClass: (Smalltalk globals at: #A2DefinedInP2)).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:53:00+01:00'!
testClassNamesAndExtensionSelectorsDo2
	"self debug: #testClassNamesAndExtensionSelectorsDo2"
	

	self assert: (String streamContents: [:stream |
		{p1 . p2 .p3} do: [:p |
			p classNamesAndExtensionSelectorsDo: [:aClassName :selector |
				stream nextPutAll: aClassName  ; nextPutAll: ' ' ; nextPutAll:  selector asString; cr ]]])
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2_class classSideMethodDefinedInP3
'.
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:42:00+01:00'!
testClassesAndExtensionMethodsDo
	"self debug: #testClassesAndExtensionMethodsDo"
	
	| block |

	self assert: (String streamContents: [:stream |
		block := [ :aClass :selectors |
				stream nextPutAll: aClass name ; nextPutAll: ' '.
				selectors do: [ :selector | stream nextPutAll: selector asString].
				stream cr.].
		{p1 . p2 . p3} do: [ :p |
			p classExtensionSlicesDo: block.
			p metaclassExtensionSlicesDo: block.]]) 
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2 classSideMethodDefinedInP3
'! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-04-20T21:49:00+01:00'!
testCompiledMethodIsDefinedInPackage
	"self debug: #testCompiledMethodIsDefinedInPackage"
	
	self assert: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isDefinedInPackage: p1).
	self deny: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isDefinedInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-03-16T17:44:00+01:00'!
testCompiledMethodIsExtensionInPackage
	"self debug: #testCompiledMethodIsExtensionInPackage"
	
	self deny: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isExtensionInPackage: p1).
	self assert: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isExtensionInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testCompiledMethodPackageFromOrganizer
	"self debug: #testCompiledMethodPackageFromOrganizer"
	| method |
	method := (Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: self packageClass organizer) = p1.
	method := (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: self packageClass organizer) = p1! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testDefinedSelectorsForClass
	"self debug: #testDefinedSelectorsForClass"
	
	self assert: (p1 definedSelectorsForClass: a1) size = 2. 
	self assert: (p1 definedMethodsForClass: a1) size = 2. 
	self assert: ((p1 definedSelectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 definedSelectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: ((p1 definedMethodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: (p1 definedSelectorsForClass: Object) isEmpty. 
	self assert: (p1 definedSelectorsForClass: Object class) isEmpty. 
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/25/2011 22:30'!
testEmpty
	"self debug: #testEmpty"
	
	self assert: p1 tags isEmpty.
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:07:00+01:00'!
testExtendingPackagesOfClass
	"since a class can be extended by several packages, we want the list of packages that extend
	the class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	| packages |
	packages := a2 extendingPackages.
	"a2 is extended by p1 and p3"
	self assert: packages size = 2. 
	self assert: (packages includes: p1).
	self deny: (packages includes: p2).
	self assert: (packages includes: p3).
	
	packages := a1 extendingPackages.
	self assert: packages isEmpty. ! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-10-27T15:49:00+01:00'!
testExtensionMethods
	"a package can extend several classes, either the class or  the meta-class side. 'extensionMethods' should list all the methods involved in shuch extensions. P3 extend a2 and a2 class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	|package extensionMethods cpt |
	package := p3.
	self shouldnt: [extensionMethods := package extensionMethods] raise: Error.
	"self assert: (extensionMethods size = 2)."
	self assert: (extensionMethods includes: (a2>>#methodDefinedInP3)).
	self assert: (extensionMethods includes: (a2 class>>#classSideMethodDefinedInP3)).	

	cpt := 0.
	package metaclassExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #classSideMethodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.
	
	cpt := 0.
	package classExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #methodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-20T22:05:00+01:00'!
testExtensionSelectorsForClass
	"self debug: #testExtensionSelectorsForClass"
	
	self assert: (p1 extensionSelectorsForClass: a2) size = 1. 
	self assert: ((p1 extensionSelectorsForClass: a2) includes: #methodDefinedInP1).
	self assert: ((p1 extensionMethodsForClass: a2) includes: (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1).
	self assert: (p1 extensionSelectorsForClass: Object) isEmpty.
	self assert: (p1 extensionSelectorsForClass: Object class) isEmpty! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-03-13T13:48:00+01:00'!
testMetaclassHasExtensions
	"self debug: #testMetaclassHasExtensions"

	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2  name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofMetaclassName: a2 name).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofClass: a2 class)

	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:38:00+01:00'!
testMethods
	"self debug: #testMethods"
	
	| m1 m3 |
	m1 := p1 methods.
	self assert: m1 size = 3. 
	self assert: (m1 includes: a1>>#methodDefinedInP1).
	self assert: (m1 includes: a1>>#anotherMethodDefinedInP1). 
	self assert: (m1 includes: a2>>#methodDefinedInP1).
	m3 := p3 methods.
	self assert: m3 size = 2.
	self assert: (m3 includes: a2>>#methodDefinedInP3).
	self assert: (m3 includes: a2 class>>#classSideMethodDefinedInP3)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testMethodsForClass
	"self debug: #testMethodsForClass"
	
	self assert: (p1 methodsForClass: a1) size = 2. 
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#anotherMethodDefinedInP1)).
	self assert: (p1 methodsForClass: b1) isEmpty. 
	self assert: (p1 methodsForClass: Object) isEmpty. 
	self assert: (p1 methodsForClass: Object class) isEmpty. 

	self assert: (p3 methodsForClass: a2) size = 1.
	self assert: ((p3 methodsForClass: a2) includes: ((Smalltalk at: #A2DefinedInP2)>>#methodDefinedInP3)).
	self assert: (p3 methodsForClass: a2 class) size = 1.
	self assert:  ((p3 methodsForClass: a2 class) includes: ((Smalltalk at: #A2DefinedInP2) class>>#classSideMethodDefinedInP3))	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:08:00+01:00'!
testPackagesOfClass
	"since a class can be extended by several packages, we want the complete list of packages that define or extend
	the class"
	"self debug: #testPackagesOfClass"
		
	| packages extending |
	packages := a2 packages.
	"a2 is extended by p1 and p3"
	extending := a2 extendingPackages.
	self assert: extending size = 2. 
	self assert: (extending includes: p1).
	self assert: (extending includes: p3).
	
	self assert: packages size = 3. 
	self assert: (packages includes: p1).
	self assert: (packages includes: p2).
	self assert: (packages includes: p3).
	
	
	
	
	
	
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:12'!
testRemoveTag
	"self debug: #testRemoveTag"
	
	self assert: p1 tags isEmpty.
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	self shouldnt: [ (p1 removeClassTag: #bar)] raise: Error.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	p1 removeClassTag: #foo.
	self deny: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 0).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:19'!
testRemoveTaggedClasses
	"self debug: #testRemoveTaggedClasses"
	
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #zork.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	self deny: ((p1 classesForClassTag: #zork) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	
	"now when we remove a class"
	"from an existing tags list"
	p1 removeClassDefinitionName: #A1DefinedInP1 fromClassTag: #foo.
	self deny: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	
	"from a nonexisting tag list"
	self shouldnt: [p1 removeClassDefinitionName: #B1DefinedInP1 fromClassTag: #taz] raise: Error.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	
	"with a class not registered to a tag list"
	self shouldnt: [p1 removeClassDefinitionName: #Tagada fromClassTag: #foo] raise: Error.
	self deny: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:13:00+01:00'!
testSelectors
	"self debug: #testSelectors"
	
	self assert: (p1 selectors) size = 2. 
	self assert: ((p1 selectors) includes: #methodDefinedInP1).
	self assert: ((p1 selectors) includes: #anotherMethodDefinedInP1). 

	self assert: p3 selectors size = 2.
	self assert: (p3 selectors includes: #methodDefinedInP3).
	self assert:  (p3 selectors includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:58:00+01:00'!
testSelectorsForClass
	"self debug: #testSelectorsForClass"
	
	self assert: (p1 selectorsForClass: a1) size = 2. 
	self assert: ((p1 selectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 selectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: (p1 selectorsForClass: b1) isEmpty. 
	self assert: (p1 selectorsForClass: Object) isEmpty. 
	self assert: (p1 selectorsForClass: Object class) isEmpty. 

	self assert: (p3 selectorsForClass: a2) size = 1.
	self assert: ((p3 selectorsForClass: a2) includes: #methodDefinedInP3).
	self assert: (p3 selectorsForClass: a2 class) size = 1.
	self assert:  ((p3 selectorsForClass: a2 class) includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: 'StephaneDucasse 4/13/2011 20:52'!
testStartingSituation
	"self debug: #testStartingSituation"

.	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).
! !

RPackageIncrementalTest subclass: #RPackageTraitTest
	instanceVariableNames: 'p4 p5 a1 b1 a2 b2 a3 t1 t2 p6'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageTraitTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:42'!
p4Name

	^ 'RPackageTestP4'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:43'!
p5Name

	^ 'RPackageTestP5'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'cyrilledelaunay 5/10/2011 12:50'!
p6Name

	^ 'RPackageTestP6'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'cyrilledelaunay 5/13/2011 12:55'!
setUp

	super setUp.
	
	p4 := self createNewPackageNamed: self p4Name.  
	p5 := self createNewPackageNamed: self p5Name. 
	p6 := self createNewPackageNamed: self p6Name.  
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p4.
	
	"a1 defines two normal = local methods"
	a1 compileSilently: 'localMethodDefinedInP1 ^ #methodDefinedInP1'.
	p4 addMethod: (a1>>#localMethodDefinedInP1).
	a1 compileSilently: 'anotherLocalMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p4 addMethod: (a1>>#anotherLocalMethodDefinedInP1).
	
	t1 := self createNewTraitNamed: #TraitInPackageP4 inPackage: p4.
	t1 compileSilently: 'traitMethodDefinedInP4 ^ #traitMethodDefinedInP4'.
	p4 addMethod: (t1>>#traitMethodDefinedInP4).
	
	"P6 defines a new method extension on T1 (packaged in p4)"
	t1 compileSilently: 'traitMethodExtendedFromP6 ^ #traitMethodExtendedFromP6' classified: ('*',self p6Name). 
	p6 addMethod: (t1>>#traitMethodExtendedFromP6).
	
	t2 := self createNewTraitNamed: #TraitInPackageP5 inPackage: p5.
	t2 compileSilently: 'traitMethodDefinedInP5 ^ #traitMethodDefinedInP5'.
	
	p5 addMethod: (t2 >> #traitMethodDefinedInP5).  
	
	"Here P4 extends T2 from P5 with a new method"
	t2 compileSilently: 'traitMethodExtendedFromP4 ^ #traitMethodExtendedFromP4' classified: ('*',self p4Name). 
	p4 addMethod: (t2 >> #traitMethodExtendedFromP4).
	
	a1 setTraitComposition: (t1 + t2) asTraitComposition.
	
	"a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3)."
	! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testPackageOfClassMethodFromTraitExtensionIsExtendingPackage
	"The package of a method defined in atrait but package in another package than the extended trait is the 
	package containing the extension."
	
	"The package of a method in A1 (which is coming from the trait T1 used by A1) is the package of T1"
	self assert: ((a1>>#traitMethodExtendedFromP4) packageFromOrganizer: self packageClass organizer) = p4.
	"The package of a method in A1 (which is coming from the trait T1 used by A1 but extended in package T2) is the package of T2"
	self assert: ((a1>>#traitMethodExtendedFromP6) packageFromOrganizer: self packageClass organizer) = p6.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfClassMethodFromTraitIsTraitPackage

	"test that a class method coming from a trait is packaged in the trait package"
	self assert: ((a1>>#traitMethodDefinedInP4) packageFromOrganizer: self packageClass organizer) = p4.
	self assert: ((a1>>#traitMethodDefinedInP5) packageFromOrganizer: self packageOrganizerClass default) = p5.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfClassMethodIsClassPackage
	"The package of a local method (not defined in a trait) is the package of its class"
	
	self assert: ((a1>>#localMethodDefinedInP1) packageFromOrganizer: self packageClass organizer) = p4.
	self assert: ((a1>>#anotherLocalMethodDefinedInP1) packageFromOrganizer: self packageOrganizerClass default) = p4.
	self assert: ((a1>>#anotherLocalMethodDefinedInP1) packageFromOrganizer: self packageClass organizer) = p4.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfTraitMethodIsTraitPackage
	"The package of a trait method is the package of its trait."

	self assert: ((a1 >> #traitMethodDefinedInP5) packageFromOrganizer: self packageClass organizer) = p5.
	self assert: ((a1 >> #traitMethodDefinedInP5)packageFromOrganizer: self packageOrganizerClass default) = p5.
	self assert: ((a1>>#traitMethodDefinedInP4) packageFromOrganizer: self packageClass organizer) = p4.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/10/2011 10:24'!
testStartingSituation
	"self debug: #testStartingSituation"


.	self deny: (p5 includesClass: a1).
	self assert: (p4 includesClass: a1).
	self assert: (p4 includesClass: t1).
	self assert: (p4 definesOrExtendsClass: a1).
	self assert: (p5 includesClass: t2).! !

RPackageTestCase subclass: #RPackageOrganizerTest
	instanceVariableNames: 'createdClasses createdPackages organizer packageOrganizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageOrganizerTest commentStamp: 'StephaneDucasse 4/24/2011 17:10' prior: 0!
RPackageOrganizerTest tests the behavior of PackageOrganizer. 
Note that it does not rely on announcement to be emitted to maintain invariants.
Therefore the new created PackageOrganizer is not registered to listen to event.

!

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'RPackageTest'.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewPackageNamed: aName

	| pack |
	self removePackageIfExist: aName.
	pack := self packageClass named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p1Name
	^ 'RPackageTestP1'! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p2Name
	^ 'RPackageTestP2'! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p3Name
	^ 'RPackageTestP3'! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: 'StephaneDucasse 4/24/2011 17:13'!
packageOrganizer

	^ packageOrganizer ! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 6/3/2012 22:51'!
pointRectangleInGraphElement 
	| p |
	p := self packageClass named: #GraphElement.
	p addClassDefinition: Point.
	p addMethod: Point>>#x.
	p addMethod: Point>>#rotateBy:about:. 
	p addClassDefinition: Rectangle.
	p addMethod: Quadrangle>>#intersect:.
	^ p! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-07-29T21:54:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol

	Smalltalk globals at: aClassNameSymbol asSymbol ifPresent: [ :c | c removeFromSystem ]! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: 'cyrilledelaunay 5/30/2011 17:19'!
removePackageIfExist: aName

	self packageOrganizer basicUnregisterPackageNamed: aName asSymbol.
		
	! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setUp
	super setUp.
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.
	packageOrganizer := self packageOrganizerClass basicNew initialize.
	packageOrganizer debuggingName: 'For PackageOrganizerTest'.
	Author fullName ifNil: [Author fullName: 'RPackage'].! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 6/3/2012 22:51'!
stringCharacterInCollPackage
	| p |
	p := self packageClass named: #CollPackage.
	p addClassDefinition: String.
	p addClassDefinition: Character.
	p addMethod: String>>#indexOf:.
	p addMethod: String>>#isAllDigits.
	p addMethod: String class>>#cr.
	p addMethod: Character>>#asInteger.
	p addMethod: Text>>#allBold.
	^ p! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: 'StephaneDucasse 4/24/2011 17:12'!
tearDown 

	(createdClasses reject: [:c| c isObsolete])
		do: [:cls| 
				"(self packageClass organizer includesClass: cls)
					ifTrue: [self packageOrganizer unregisterClass: cls.]."
				cls removeFromSystem ].
	"createdPackages do:
		[:each | self packageOrganizer unregisterPackage: each]"! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:52'!
testAccessingPackage
	"self debug: #testAccessingPackage"

	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: (self packageOrganizer packageNamed: #P1) = p1.
	self should: [(self packageOrganizer packageNamed: #P22)] raise: Error! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:52'!
testDefinedClassesInstanceAndMetaSideAPI
	"self debug: #testDefinedClassesInstanceAndMetaSideAPI"
	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: self packageOrganizer packageNames size = 2.
	self assert: self packageOrganizer packages size = 2.
	self assert: (self packageOrganizer packageNamed: #P1) definedClasses size = 1! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:51'!
testEmpty
	"self debug: #testEmpty"
	self assert: self packageOrganizer packageNames size = 1.
	self assert: (self packageOrganizer packageNames includes: self packageClass defaultPackageName)
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:50'!
testFullRegistration
	"self debug: #testFullRegistration"

	| p1 p2 p3 a1 a2 b1 b2 a3 |
	"taken from setup of RPackageReadOnlyCompleteSetup"
	
p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:18'!
testFullUnregistration
	"self debug: #testFullRegistration"

	| p1 p2 p3 a1 a2 b1 b2 a3 |
	"taken from setup of RPackageReadOnlyCompleteSetup"
	
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	
	self packageOrganizer unregisterPackage: p1.
	self packageOrganizer unregisterPackage: p2.
	self packageOrganizer unregisterPackage: p3.
	

	self deny: (self packageOrganizer includesPackageBackPointerForClass: a1).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: a2).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: b1).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: b2).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: a3).
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:53'!
testRegisteredIsIncludedInPackageNames
	"self debug: #testRegisteredIsIncludedInPackageNames"
	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self assert: (self packageOrganizer includesPackage: p1). 
	self assert: (self packageOrganizer includesPackageNamed: p1 name). 
	{p1 . p2 . p3} do: [:each | self assert:  (self packageOrganizer packageNames includes: each name)]

! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:25'!
testRegisteredIsThere
	"self debug: #testRegisteredIsThere"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	
	{p1 . p2 . p3} do: [:each | 
		self assert:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:10'!
testRegisteredNumberOfPackageIsOk
	"self debug: #testRegisteredNumberOfPackageIsOk"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self packageOrganizer basicUnregisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 3.! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 4/24/2011 17:18'!
testRegistrationExtendingPackages
	"self debug: #testRegistrationExtendingPackages"

	| p |
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	p := self pointRectangleInGraphElement.
	(self packageOrganizer
					registerExtendingPackage:  p
					forClass: Quadrangle).
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:19'!
testUnregisterBasedOnNames
	"self debug: #testUnregisterBasedOnNames"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.

	{p1 . p2 . p3} do: [:each | 
		(self packageOrganizer basicUnregisterPackageNamed: each name).
		self deny:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: '2011-01-31T11:52:00+01:00'!
testUnregistrationExtendingPackages
	"self debug: #testUnregistrationExtendingPackages"

	| p |
	p := self pointRectangleInGraphElement.
	self packageOrganizer
		registerExtendingPackage: p
		forClass: Quadrangle.
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	self packageOrganizer
					unregisterExtendingPackage:  p
					forClass: Quadrangle.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	! !

!RPackageTestCase methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 19:43'!
allManagers

	^ MCWorkingCopy allManagers! !

!RPackageTestCase methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 7/27/2012 19:48'!
initializeAnnouncers
	oldMCAnnouncer := SystemAnnouncer uniqueInstance.
	oldPrivateAnnouncer := SystemAnnouncer privateAnnouncer.
	SystemAnnouncer announcer: (announcerForTest := SystemAnnouncer new).
	SystemAnnouncer privateAnnouncer: (privateAnnouncerForTest := SystemAnnouncer new).! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:44'!
organizer
	"This method will access the organizer that will temporarily swapped using the withOrganizer:do: method"
	^ self packageClass organizer! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:44'!
packageClass 
	"returns the system class that represents Packages"
	^ RPackage ! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 23:25'!
packageOrganizerClass 
	"returns the package organizer class"
	^ RPackageOrganizer! !

!RPackageTestCase methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 7/27/2012 19:16'!
restoreAnnouncers
	SystemAnnouncer announcer: oldMCAnnouncer.
	SystemAnnouncer privateAnnouncer: oldPrivateAnnouncer.! !

!RPackageTestCase methodsFor: 'running' stamp: 'GuillermoPolito 7/23/2012 13:45'!
runCase
	[
	self initializeAnnouncers.
	
	^ self packageClass 
		withOrganizer: self setupOrganizer
		do: [ 
			self resources do: [:each | each availableFor: self].
			self setUp.
			self performTest
			]
	] ensure: [ 
		self tearDown.
		self restoreAnnouncers.
		self cleanUpInstanceVariables
	]! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setupOrganizer
	^ self packageOrganizerClass basicNew initialize; debuggingName: 'Organizer for RPackageTest'; yourself! !

TestCase subclass: #RPackageWithDoTest
	instanceVariableNames: 'x'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageWithDoTest methodsFor: 'accessing' stamp: 'StephaneDucasse 10/16/2011 20:56'!
announcer
	^ SystemAnnouncer privateAnnouncer! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:17'!
do: aBlock 

	x := 5.
	[aBlock value] ensure: [x :=3.]! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 12:26'!
doC: aBlock 
	
	x := 5.
	[aBlock value] ifCurtailed: [x :=3]! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:24'!
doOnDo: aBlock 
	
	x := 5.
	[aBlock value.
	self ensure] on: Error do:  [:ex | self ensure].! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:24'!
ensure

	x := 3! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'IgorStasenko 8/12/2011 16:37'!
info
	
	
	self announcer hasSubscriber: RPackageOrganizer default.
	Smalltalk garbageCollect.
	RPackageOrganizer allInstances collect: [:each | self announcer hasSubscriber: each ] ! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:49'!
packageClass
	^ RPackage! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
packageOrganizerClass
	^ RPackageOrganizer! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:19'!
testDo
	"self run: #testDo"
	
	[self do: [ Error signal]] on:Error do: [:ex|].
	"necessary else SUnit believe that the error is not handle"
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:14'!
testDo2
	"self run: #testDo2"
	
	[self do: [ self error]
		] on: Error do: [:ex | ].
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:20'!
testDoC
	"self run: #testDoC"
	
	[self doC: [ self error]] on: Error do: [:e|].
	"necessary for SUnit"
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
testInvariant
	"The default invariant"
	"self run: #testInvariant"
	
	self assert: (self packageOrganizerClass default packageNames size > 50).
	"to be sure that this is real default one"
	self assert: (self announcer hasSubscriber: self packageOrganizerClass default).
	"note that this test is not precise enough because I could get the wrong one."
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	self assert: (self packageOrganizerClass allInstances size = 1).
	
	self packageOrganizerClass allInstances collect: [:each | self announcer hasSubscriber: each ] 
	"To debug..."! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:20'!
testOnDo
	"self run: #testOnDo"
	
	self doOnDo: [ self error].
	self assert: x = 3.
	x := 77.
	self doOnDo: [x = 21].
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
testWithDoIsCorrectlyReinstallingDefault
	"self debug: #testWithDoIsCorrectlyReinstallingDefault"
	
	| current empty |
	current := self packageOrganizerClass default.  
	empty := self packageOrganizerClass basicNew initialize.
	empty debuggingName: 'empty from PackageWithDoTest'.
	self packageClass withOrganizer: empty
		 do: [ self assert: (self announcer hasSubscriber: empty).
			self deny: (self announcer hasSubscriber: current)].
	self assert: (self announcer hasSubscriber: current).
	self deny: (self announcer hasSubscriber: empty)
		
		


! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
testWithDoIsCorrectlyReinstallingDefaultEvenIfHalt
	"self debug: #testWithDoIsCorrectlyReinstallingDefaultEvenIfHalt"
	
	| current empty |
	current := self packageOrganizerClass default.  
	empty := self packageOrganizerClass basicNew initialize.
	[self packageClass withOrganizer: empty
		 do: [ 		
			self assert: (self announcer hasSubscriber: empty).
			self deny: (self announcer hasSubscriber: current).
			self error]]
		on: Error do: [:ex|].
	
	self assert: (self announcer hasSubscriber: current).
	self deny: (self announcer hasSubscriber: empty)
		
		


! !

Object subclass: #RBRefactoryChange
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

RBRefactoryChange subclass: #RBCompositeRefactoryChange
	instanceVariableNames: 'changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBCompositeRefactoryChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:43'!
named: aString
	^ self new
		name: aString;
		yourself! !

!RBCompositeRefactoryChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 17:27'!
= aRefactoryBuilder 
	self class = aRefactoryBuilder class
		ifFalse: [ ^ false ].
	changes size = aRefactoryBuilder changes size
		ifFalse: [ ^ false ].
	changes with: aRefactoryBuilder changes do: [ :first :second |
		first = second
			ifFalse: [ ^ false ] ].
	^ true! !

!RBCompositeRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:27'!
addChange: aRefactoryChange 
	changes add: aRefactoryChange.
	^ aRefactoryChange! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
addClassVariable: variableName to: aClass 
	^ self addChange: (RBAddClassVariableChange add: variableName to: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
addInstanceVariable: variableName to: aClass 
	^ self addChange: (RBAddInstanceVariableChange add: variableName to: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
addPool: aPoolVariable to: aClass 
	^ self addChange: (RBAddPoolVariableChange add: aPoolVariable to: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 11:29'!
changeForClass: aClassName selector: aSelector 
	changes reverseDo: [ :each | 
		| change |
		change := each changeForClass: aClassName selector: aSelector.
		change notNil ifTrue: [ ^ change ] ].
	^ nil! !

!RBCompositeRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 11:30'!
changeForMetaclass: aClassName selector: aSelector 
	changes reverseDo: [ :each | 
		| change |
		change := each changeForMetaclass: aClassName selector: aSelector.
		change notNil ifTrue: [ ^ change ] ].
	^ nil! !

!RBCompositeRefactoryChange methodsFor: 'private-inspector accessing' stamp: 'lr 9/6/2010 17:28'!
changes
	^ changes! !

!RBCompositeRefactoryChange methodsFor: 'private-inspector accessing' stamp: ''!
changes: aCollection 
	changes := aCollection! !

!RBCompositeRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:27'!
changesSize
	^ changes inject: 0 into: [ :sum :each | sum + each changesSize ]! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
comment: aString in: aClass 
	^ self addChange: (RBCommentChange comment: aString in: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
compile: source in: class 
	^ self addChange: (RBAddMethodChange compile: source in: class)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
compile: source in: class classified: aProtocol 
	^ self addChange: (RBAddMethodChange compile: source in: class classified: aProtocol)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
defineClass: aString 
	^ self addChange: (RBAddClassChange definition: aString)! !

!RBCompositeRefactoryChange methodsFor: 'private' stamp: 'lr 5/9/2010 11:31'!
executeNotifying: aBlock 
	| undos undo |
	undos := changes collect: [ :each | each executeNotifying: aBlock ].
	undo := self copy.
	undo changes: undos reversed.
	^ undo! !

!RBCompositeRefactoryChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 17:31'!
hash
	^ self class hash bitXor: self changes size hash! !

!RBCompositeRefactoryChange methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	changes := OrderedCollection new! !

!RBCompositeRefactoryChange methodsFor: 'copying' stamp: 'lr 9/6/2010 17:27'!
postCopy
	super postCopy.
	changes := changes collect: [ :each | each copy ]! !

!RBCompositeRefactoryChange methodsFor: 'printing' stamp: 'lr 9/6/2010 17:28'!
printOn: aStream 
	name isNil
		ifTrue: [ ^ super printOn: aStream ].
	aStream nextPutAll: name! !

!RBCompositeRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:27'!
problemCount
	^ self changesSize! !

!RBCompositeRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:29'!
removeChange: aChange 
	^ changes remove: aChange ifAbsent: [ nil ]! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
removeClass: aClass 
	^ self addChange: (RBRemoveClassChange removeClassName: aClass name)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
removeClassNamed: aSymbol 
	^ self addChange: (RBRemoveClassChange removeClassName: aSymbol)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
removeClassVariable: variableName from: aClass 
	^ self addChange: (RBRemoveClassVariableChange remove: variableName from: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
removeInstanceVariable: variableName from: aClass 
	^ self addChange: (RBRemoveInstanceVariableChange remove: variableName from: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
removeMethod: aSelector from: aClass 
	^ self addChange: (RBRemoveMethodChange remove: aSelector from: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
removePool: aPoolVariable from: aClass 
	^ self addChange: (RBRemovePoolVariableChange remove: aPoolVariable from: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 13:56'!
renameChangesForClass: oldClassName to: newClassName
	^ self copy
		changes: (self changes 
			collect: [ :each | each renameChangesForClass: oldClassName to: newClassName ]);
		yourself! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
renameClass: class to: newName 
	^ self addChange: (RBRenameClassChange rename: class name to: newName)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
renameClassVariable: oldName to: newName in: aClass
	^ self addChange: (RBRenameClassVariableChange rename: oldName to: newName in: aClass)! !

!RBCompositeRefactoryChange methodsFor: 'refactory-changes' stamp: 'lr 9/8/2011 20:10'!
renameInstanceVariable: oldName to: newName in: aClass
	^ self addChange: (RBRenameInstanceVariableChange rename: oldName to: newName in: aClass)! !

RBCompositeRefactoryChange subclass: #RBRenameClassChange
	instanceVariableNames: 'oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRenameClassChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:43'!
rename: oldString to: newString 
	^ self new
		rename: oldString to: newString;
		yourself! !

!RBRenameClassChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 17:33'!
= aRenameClassChange 
	super class = aRenameClassChange class
		ifFalse: [ ^ false ].
	^oldName = aRenameClassChange oldName 
		and: [ newName = aRenameClassChange newName ]! !

!RBRenameClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:30'!
changeClass
	^ Smalltalk globals at: oldName asSymbol ifAbsent: [ Smalltalk globals at: newName asSymbol ]! !

!RBRenameClassChange methodsFor: 'private' stamp: 'lr 9/6/2010 17:31'!
executeNotifying: aBlock 
	| undos |
	self changeClass rename: newName.
	undos := changes collect: [ :each | 
		(each renameChangesForClass: oldName asSymbol to: newName asSymbol) 
			executeNotifying: aBlock ].
	^ self copy
		changes: undos reverse;
		rename: newName to: oldName;
		yourself! !

!RBRenameClassChange methodsFor: 'comparing' stamp: 'lr 5/18/2010 20:56'!
hash
	^ (self class hash bitXor: self oldName hash) bitXor: self newName hash! !

!RBRenameClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:31'!
newName
	^ newName! !

!RBRenameClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:31'!
oldName
	^ oldName! !

!RBRenameClassChange methodsFor: 'printing' stamp: 'lr 2/7/2008 22:18'!
printOn: aStream 
	aStream
		nextPutAll: self oldName;
		nextPutAll: ' rename: ';
		print: self newName;
		nextPut: $!!! !

!RBRenameClassChange methodsFor: 'initialize-release' stamp: ''!
rename: oldString to: newString 
	oldName := oldString.
	newName := newString! !

!RBRenameClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 13:57'!
renameChangesForClass: oldClassName to: newClassName
	| change |
	change := super renameChangesForClass: oldClassName to: newClassName.
	oldName asSymbol = oldClassName
		ifTrue: [ change rename: newClassName to: newName ].
	^ change! !

RBCompositeRefactoryChange subclass: #RBRenameVariableChange
	instanceVariableNames: 'className isMeta oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

RBRenameVariableChange subclass: #RBRenameClassVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRenameClassVariableChange methodsFor: 'private' stamp: 'lr 9/8/2011 20:10'!
addNewVariable
	(RBAddClassVariableChange add: newName to: self changeClass)
		execute! !

!RBRenameClassVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 13:48'!
copyOldValuesToNewVariable
	| oldValue |
	oldValue := self changeClass classPool at: oldName ifAbsent: [ nil ].
	self changeClass classPool at: newName asSymbol put: oldValue! !

!RBRenameClassVariableChange methodsFor: 'printing' stamp: 'lr 5/18/2010 20:37'!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeClassVarName: ';
		print: self oldName;
		nextPut: $!!; cr.
	aStream
		nextPutAll: self displayClassName; 
		nextPutAll: ' addClassVarName: '; 
		print: self newName;
		nextPut: $!!! !

!RBRenameClassVariableChange methodsFor: 'private' stamp: 'lr 9/8/2011 20:10'!
removeOldVariable
	(RBRemoveClassVariableChange remove: oldName from: self changeClass)
		execute! !

RBRenameVariableChange subclass: #RBRenameInstanceVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRenameInstanceVariableChange methodsFor: 'private' stamp: 'lr 9/8/2011 20:10'!
addNewVariable
	(RBAddInstanceVariableChange add: newName to: self changeClass)
		execute! !

!RBRenameInstanceVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 13:48'!
copyOldValuesToNewVariable
	| newIndex oldIndex |
	oldIndex := self changeClass allInstVarNames indexOf: oldName asString.
	newIndex := self changeClass allInstVarNames indexOf: newName asString.
	self changeClass withAllSubclasses do: [ :class |
		class allInstances 
			do: [ :each | each instVarAt: newIndex put: (each instVarAt: oldIndex) ] ]! !

!RBRenameInstanceVariableChange methodsFor: 'printing' stamp: 'lr 5/18/2010 20:39'!
printOn: aStream
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeInstVarName: ';
		print: self oldName;
		nextPut: $!!; cr.
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' addInstVarName: ';
		print: self newName;
		nextPut: $!!! !

!RBRenameInstanceVariableChange methodsFor: 'private' stamp: 'lr 9/8/2011 20:10'!
removeOldVariable
	(RBRemoveInstanceVariableChange remove: oldName from: self changeClass) 
		execute! !

!RBRenameVariableChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:43'!
rename: oldName to: newName in: aClass 
	^ self new
		oldName: oldName;
		newName: newName;
		changeClass: aClass;
		yourself! !

!RBRenameVariableChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 17:34'!
= aRenameVariableChange 
	self class = aRenameVariableChange class 
		ifFalse: [ ^ false ].
	^ className = aRenameVariableChange changeClassName 
		and: [ isMeta = aRenameVariableChange isMeta 
		and: [ oldName = aRenameVariableChange oldName 
		and: [ newName = aRenameVariableChange newName ] ] ]! !

!RBRenameVariableChange methodsFor: 'private' stamp: ''!
addNewVariable
	self subclassResponsibility! !

!RBRenameVariableChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:32'!
changeClass
	| class |
	class := Smalltalk globals at: self changeClassName ifAbsent: [ ^ nil ].
	^ isMeta ifTrue: [ class class ] ifFalse: [ class ]! !

!RBRenameVariableChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:32'!
changeClass: aBehavior
	isMeta := aBehavior isMeta.
	className := isMeta
		ifTrue: [ aBehavior soleInstance name ]
		ifFalse: [ aBehavior name ]! !

!RBRenameVariableChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:32'!
changeClassName
	^ className! !

!RBRenameVariableChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:32'!
changeClassName: aSymbol
	className := aSymbol.
	isMeta isNil
		ifTrue: [ isMeta := false ]! !

!RBRenameVariableChange methodsFor: 'printing' stamp: 'lr 9/6/2010 17:34'!
changeString
	^ 'Rename ' , oldName , ' to ' , newName! !

!RBRenameVariableChange methodsFor: 'private' stamp: ''!
copyOldValuesToNewVariable
	self subclassResponsibility! !

!RBRenameVariableChange methodsFor: 'printing' stamp: 'lr 9/6/2010 21:17'!
displayClassName
	^ isMeta
		ifTrue: [ self changeClassName , ' class' ]
		ifFalse: [ self changeClassName asString ]! !

!RBRenameVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 13:46'!
executeNotifying: aBlock 
	| undo |
	self addNewVariable.
	self copyOldValuesToNewVariable.
	undo := super executeNotifying: aBlock.
	undo
		oldName: newName;
		newName: oldName.
	self removeOldVariable.
	^ undo! !

!RBRenameVariableChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 17:33'!
hash
	^ (self class hash bitXor: self oldName hash) bitXor: self newName hash! !

!RBRenameVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 13:46'!
isMeta
	^ isMeta! !

!RBRenameVariableChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:32'!
newName
	^ newName! !

!RBRenameVariableChange methodsFor: 'private' stamp: ''!
newName: aString 
	newName := aString! !

!RBRenameVariableChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 17:32'!
oldName
	^ oldName! !

!RBRenameVariableChange methodsFor: 'private' stamp: ''!
oldName: aString
	oldName := aString! !

!RBRenameVariableChange methodsFor: 'printing' stamp: 'lr 9/6/2010 13:55'!
printOn: aStream
	aStream nextPutAll: self displayString! !

!RBRenameVariableChange methodsFor: 'private' stamp: ''!
removeOldVariable
	self subclassResponsibility! !

!RBRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 11:29'!
changeForClass: aClassName selector: aSelector 
	^ nil! !

!RBRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 11:29'!
changeForMetaclass: aClassName selector: aSelector 
	^ nil! !

!RBRefactoryChange methodsFor: 'printing' stamp: ''!
changeString
	^self class name! !

!RBRefactoryChange methodsFor: 'accessing' stamp: ''!
changes
	^Array with: self! !

!RBRefactoryChange methodsFor: 'accessing' stamp: ''!
changesSize
	^1! !

!RBRefactoryChange methodsFor: 'printing' stamp: ''!
displayString
	^name isNil ifTrue: [self changeString] ifFalse: [name]! !

!RBRefactoryChange methodsFor: 'performing-changes' stamp: ''!
execute
	^self executeNotifying: []! !

!RBRefactoryChange methodsFor: 'private' stamp: ''!
executeNotifying: aBlock 
	self subclassResponsibility! !

!RBRefactoryChange methodsFor: 'accessing' stamp: ''!
name
	^name isNil ifTrue: [self changeString] ifFalse: [name]! !

!RBRefactoryChange methodsFor: 'initialize-release' stamp: ''!
name: aString
	name := aString! !

!RBRefactoryChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 13:56'!
renameChangesForClass: oldClassName to: newClassName
	"We're in the middle of performing a rename operation. If we stored the class name, we need to change the class name to the new name to perform the compiles."

	self subclassResponsibility! !

RBRefactoryChange subclass: #RBRefactoryClassChange
	instanceVariableNames: 'className isMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

RBRefactoryClassChange subclass: #RBAddMethodChange
	instanceVariableNames: 'source selector protocols controller definedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddMethodChange class methodsFor: 'instance creation' stamp: 'lr 9/30/2010 20:12'!
compile: aString in: aClass
	^ self compile: aString in: aClass for: nil! !

!RBAddMethodChange class methodsFor: 'instance creation' stamp: 'lr 9/30/2010 20:12'!
compile: aString in: aBehavior classified: aProtocol
	^ self compile: aString in: aBehavior classified: aProtocol for: nil! !

!RBAddMethodChange class methodsFor: 'instance creation' stamp: 'lr 9/30/2010 20:04'!
compile: aString in: aBehavior classified: aProtocol for: aController
	^ self new class: aBehavior protocol: aProtocol source: aString controller: aController! !

!RBAddMethodChange class methodsFor: 'instance creation' stamp: 'lr 9/30/2010 20:04'!
compile: aString in: aClass for: aController
	^ self new class: aClass source: aString contoller: aController! !

!RBAddMethodChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 21:24'!
= anAddMethodChange
	super = anAddMethodChange
		ifFalse: [ ^ false ].
	^ self parseTree = anAddMethodChange parseTree! !

!RBAddMethodChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:25'!
asUndoOperation
	^ (self changeClass includesSelector: self selector)
		ifTrue: [ 
			| oldProtocol |
			oldProtocol := RBBrowserEnvironment new whichProtocolIncludes: self selector in: self changeClass.
			oldProtocol isNil
				ifTrue: [ oldProtocol := #accessing ].
			RBAddMethodChange compile: (self methodSourceFor: self selector) in: self changeClass classified: oldProtocol ]
		ifFalse: [ RBRemoveMethodChange remove: selector from: self changeClass ]! !

!RBAddMethodChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 11:28'!
changeForClass: aClassName selector: aSelector 
	^ (isMeta not and: [ self selector = aSelector and: [ className = aClassName ] ])
		ifTrue: [ self ]
		ifFalse: [ nil ]! !

!RBAddMethodChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 11:29'!
changeForMetaclass: aClassName selector: aSelector 
	^ (isMeta and: [ self selector = aSelector and: [ className = aClassName ] ])
		ifTrue: [ self ]
		ifFalse: [ nil ]! !

!RBAddMethodChange methodsFor: 'printing' stamp: 'lr 4/7/2010 08:22'!
changeString
	^ self displayClassName , '>>' , self selector! !

!RBAddMethodChange methodsFor: 'initialize-release' stamp: ''!
class: aClass protocol: aProtocol source: aString 
	self changeClass: aClass.
	self protocols: aProtocol.
	source := aString! !

!RBAddMethodChange methodsFor: 'initialize-release' stamp: 'lr 9/30/2010 20:04'!
class: aClass protocol: aProtocol source: aString controller: aController 
	self changeClass: aClass.
	self protocols: aProtocol.
	source := aString.
	controller := aController! !

!RBAddMethodChange methodsFor: 'initialize-release' stamp: 'lr 9/8/2011 20:25'!
class: aClass source: aString contoller: aController
	self changeClass: aClass.
	source := aString.
	self protocols: (RBBrowserEnvironment new whichProtocolIncludes: self selector in: aClass).
	controller := aController! !

!RBAddMethodChange methodsFor: 'private' stamp: 'lr 9/30/2010 20:02'!
controller
	^ controller! !

!RBAddMethodChange methodsFor: 'initialize-release' stamp: 'lr 9/30/2010 20:02'!
controller: aController 
	controller := aController! !

!RBAddMethodChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 20:02'!
definedSelector
	^ definedSelector! !

!RBAddMethodChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 21:25'!
hash
	^ self parseTree hash! !

!RBAddMethodChange methodsFor: 'private' stamp: 'lr 9/6/2010 21:27'!
parseTree
	^ RBParser parseMethod: source onError: [ :str :pos | ^ nil ]! !

!RBAddMethodChange methodsFor: 'private' stamp: 'lr 10/14/2010 20:50'!
primitiveExecute
	definedSelector := self changeClass 
		compile: self source
		classified: self protocol
		notifying: self controller! !

!RBAddMethodChange methodsFor: 'printing' stamp: 'lr 12/29/2011 17:42'!
printOn: aStream 
	aStream
		nextPut: $!!;
		nextPutAll: self displayClassName;
		nextPutAll: ' methodsFor: ''';
		nextPutAll: self protocol;
		nextPutAll: ''' stamp: ';
		print: RBPlatform current changeStamp;
		nextPut: $!!;
		cr;
		nextPutAll: (source copyReplaceAll: '!!' with: '!!!!');
		nextPutAll: '!! !!'! !

!RBAddMethodChange methodsFor: 'accessing' stamp: 'lr 9/7/2010 19:10'!
protocol
	^ self protocols first! !

!RBAddMethodChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 21:24'!
protocols
	^ protocols! !

!RBAddMethodChange methodsFor: 'initialize-release' stamp: 'lr 9/7/2010 19:10'!
protocols: aCollection
	protocols := aCollection isString
		ifTrue: [ Array with: aCollection ]
		ifFalse: [ aCollection ].
	protocols isNil
		ifTrue: [ protocols := #(accessing) ]! !

!RBAddMethodChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 21:24'!
selector
	selector isNil ifTrue: [ 
		selector := RBParser parseMethodPattern: source.
		selector isNil
			ifTrue: [ selector := #unknown ] ].
	^ selector! !

!RBAddMethodChange methodsFor: 'accessing' stamp: 'lr 11/1/2009 23:25'!
source
	^ source! !

RBRefactoryClassChange subclass: #RBCommentChange
	instanceVariableNames: 'comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBCommentChange class methodsFor: 'instance creation' stamp: 'lr 7/1/2008 10:50'!
comment: aString in: aClass
	^ self new
		changeClass: aClass;
		comment: aString;
		yourself! !

!RBCommentChange methodsFor: 'converting' stamp: 'lr 9/6/2010 10:48'!
asUndoOperation
	^ self copy
		comment: self changeClass organization classComment;
		yourself! !

!RBCommentChange methodsFor: 'accessing' stamp: 'lr 7/1/2008 10:44'!
changeClass: aBehavior
	super changeClass: aBehavior.
	isMeta := false! !

!RBCommentChange methodsFor: 'printing' stamp: 'lr 7/1/2008 10:48'!
changeString
	^ 'Comment ' , self displayClassName! !

!RBCommentChange methodsFor: 'accessing' stamp: 'lr 7/1/2008 10:41'!
comment
	^ comment! !

!RBCommentChange methodsFor: 'accessing' stamp: 'lr 7/1/2008 10:41'!
comment: aString 
	comment := aString! !

!RBCommentChange methodsFor: 'private' stamp: 'EstebanLorenzano 7/27/2012 16:30'!
primitiveExecute
	self changeClass 
		classComment: comment
		stamp: RBPlatform current changeStamp.
	SystemAnnouncer uniqueInstance 
		classCommented: self changeClass! !

!RBCommentChange methodsFor: 'printing' stamp: 'lr 12/29/2011 17:42'!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' classComment: ';
		print: (self comment copyReplaceAll: '!!' with: '!!!!');
		nextPutAll: ' stamp: ';
		print: (RBPlatform current changeStamp);
		nextPutAll: '!!'! !

!RBRefactoryClassChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 21:18'!
= aRefactoryClassChange 
	self class = aRefactoryClassChange class
		ifFalse: [ ^ false ].
	^ className = aRefactoryClassChange changeClassName 
		and: [ isMeta = aRefactoryClassChange isMeta ]! !

!RBRefactoryClassChange methodsFor: 'converting' stamp: ''!
asUndoOperation
	^self subclassResponsibility! !

!RBRefactoryClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 21:18'!
changeClass
	| class |
	class := Smalltalk globals at: self changeClassName ifAbsent: [ ^ nil ].
	^ isMeta ifTrue: [ class classSide ] ifFalse: [ class ]! !

!RBRefactoryClassChange methodsFor: 'accessing' stamp: 'lr 10/31/2009 17:37'!
changeClass: aBehavior 
	isMeta := aBehavior isMeta.
	className := aBehavior theNonMetaClass name! !

!RBRefactoryClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 21:19'!
changeClassName
	^ className! !

!RBRefactoryClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 21:19'!
changeClassName: aSymbol 
	className := aSymbol.
	isMeta isNil ifTrue: [ isMeta := false ]! !

!RBRefactoryClassChange methodsFor: 'printing' stamp: 'lr 9/6/2010 21:19'!
changeString
	^ self displayClassName! !

!RBRefactoryClassChange methodsFor: 'printing' stamp: 'lr 9/6/2010 21:19'!
displayClassName
	^ isMeta
		ifTrue: [ self changeClassName , ' class' ]
		ifFalse: [ self changeClassName asString ]! !

!RBRefactoryClassChange methodsFor: 'private' stamp: 'lr 9/6/2010 21:19'!
executeNotifying: aBlock
	| undo |
	undo := self asUndoOperation.
	undo name: self name.
	self primitiveExecute.
	aBlock value.
	^ undo! !

!RBRefactoryClassChange methodsFor: 'comparing' stamp: 'lr 9/6/2010 21:19'!
hash
	^ self changeClassName hash! !

!RBRefactoryClassChange methodsFor: 'private' stamp: 'lr 9/6/2010 21:19'!
isMeta
	^ isMeta! !

!RBRefactoryClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 21:19'!
methodSourceFor: aSymbol
	^ (self changeClass includesSelector: aSymbol)
		ifTrue: [ self changeClass sourceCodeAt: aSymbol ]! !

!RBRefactoryClassChange methodsFor: 'private' stamp: 'lr 9/6/2010 13:29'!
primitiveExecute
	^ self subclassResponsibility! !

!RBRefactoryClassChange methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: self displayString! !

!RBRefactoryClassChange methodsFor: 'accessing' stamp: 'lr 9/6/2010 13:57'!
renameChangesForClass: oldClassName to: newClassName
	^ self changeClassName = oldClassName
		ifFalse: [ self ]
		ifTrue: [
			self copy
				changeClassName: newClassName;
				yourself ]! !

RBRefactoryClassChange subclass: #RBRefactoryDefinitionChange
	instanceVariableNames: 'controller definition definedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

RBRefactoryDefinitionChange subclass: #RBAddClassChange
	instanceVariableNames: 'superclassName instanceVariableNames classVariableNames poolDictionaryNames category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddClassChange class methodsFor: 'private' stamp: 'lr 10/2/2010 13:32'!
definitionPatterns
	^ #('`@superclass subclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass subclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableByteSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableByteSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableWordSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass variableWordSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass weakSubclass: `#className instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category'
		'`@superclass weakSubclass: `#className uses: `@traitComposition instanceVariableNames: `#instanceVariableNames classVariableNames: `#classVariableNames poolDictionaries: `#poolDictionaries category: `#category')
		gather: [ :each | Array with: each with: (each copyReplaceAll: '`@superclass' with: 'ProtoObject') , '. `className superclass: `@superclass' ]! !

!RBAddClassChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	| class |
	class := Smalltalk globals
		at: self changeClassName
		ifAbsent: [ nil ].
	^ class isBehavior
		ifTrue: [ RBAddClassChange definition: class definition ]
		ifFalse: [ RBRemoveClassChange removeClassName: self changeClassName ]! !

!RBAddClassChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 18:52'!
category
	^ category! !

!RBAddClassChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 18:52'!
classVariableNames
	^ classVariableNames! !

!RBAddClassChange methodsFor: 'private' stamp: 'lr 10/2/2010 13:37'!
definitionClass
	^ Smalltalk globals at: (self superclassName ifNil: [ ^ ProtoObject ])! !

!RBAddClassChange methodsFor: 'private' stamp: 'lr 10/1/2010 14:36'!
fillOutDefinition: aDictionary
	superclassName := (aDictionary at: '`@superclass')
		ifNotNil: [ :value | value asSymbol ].
	className := (aDictionary at: '`#className') asSymbol.
	instanceVariableNames := self namesIn: (aDictionary
		at: '`#instanceVariableNames'
		ifAbsent: [ String new ]).
	classVariableNames := self namesIn: (aDictionary
		at: '`#classVariableNames'
		ifAbsent: [ String new ]).
	poolDictionaryNames := self namesIn: (aDictionary
		at: '`#poolDictionaries'
		ifAbsent: [ String new ]).
	category := (aDictionary
		at: '`#category'
		ifAbsent: [ #Unclassified ])
			asSymbol! !

!RBAddClassChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 18:52'!
instanceVariableNames
	^ instanceVariableNames! !

!RBAddClassChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 18:52'!
poolDictionaryNames
	^ poolDictionaryNames! !

!RBAddClassChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 18:52'!
superclassName
	^ superclassName! !

RBRefactoryDefinitionChange subclass: #RBAddClassTraitChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddClassTraitChange class methodsFor: 'private' stamp: 'lr 9/30/2010 19:46'!
definitionPatterns
	^ #('`traitName classTrait uses: `@traitComposition')! !

!RBAddClassTraitChange methodsFor: 'converting' stamp: 'lr 9/30/2010 19:47'!
asUndoOperation
	^ self class definition: self changeClass classTrait definition! !

!RBAddClassTraitChange methodsFor: 'private' stamp: 'lr 9/30/2010 19:47'!
definitionClass
	^ self changeClass! !

!RBAddClassTraitChange methodsFor: 'initialization' stamp: 'lr 10/1/2010 14:36'!
fillOutDefinition: aDictionary
	className := (aDictionary at: '`traitName') asSymbol! !

RBRefactoryDefinitionChange subclass: #RBAddMetaclassChange
	instanceVariableNames: 'classInstanceVariableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddMetaclassChange class methodsFor: 'private' stamp: 'lr 9/30/2010 19:19'!
definitionPatterns
	^ #('`className class instanceVariableNames: `#instanceVariableNames'
		'`className class uses: `@traitComposition instanceVariableNames: `#instanceVariableNames')! !

!RBAddMetaclassChange methodsFor: 'converting' stamp: 'lr 9/30/2010 14:32'!
asUndoOperation
	^ self class definition: self changeClass class definition! !

!RBAddMetaclassChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 18:57'!
classInstanceVariableNames
	^ classInstanceVariableNames! !

!RBAddMetaclassChange methodsFor: 'private' stamp: 'lr 9/30/2010 14:21'!
definitionClass
	^ self changeClass! !

!RBAddMetaclassChange methodsFor: 'initialization' stamp: 'lr 10/1/2010 14:37'!
fillOutDefinition: aDictionary
	className := (aDictionary at: '`className') asSymbol.
	classInstanceVariableNames := self namesIn: (aDictionary
		at: '`#instanceVariableNames'
		ifAbsent: [ String new ])! !

RBRefactoryDefinitionChange subclass: #RBAddTraitChange
	instanceVariableNames: 'category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddTraitChange class methodsFor: 'private' stamp: 'lr 9/30/2010 19:46'!
definitionPatterns
	^ #('Trait named: `#traitName uses: `@traitComposition category: `#category')! !

!RBAddTraitChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	| trait |
	trait := Smalltalk globals
		at: self changeClassName
		ifAbsent: [ nil ].
	^ trait isTrait
		ifTrue: [ RBAddTraitChange definition: trait definition ]
		ifFalse: [ RBRemoveClassChange removeClassName: self changeClassName ]! !

!RBAddTraitChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 19:29'!
category
	^ category! !

!RBAddTraitChange methodsFor: 'private' stamp: 'lr 9/30/2010 19:39'!
definitionClass
	^ Trait! !

!RBAddTraitChange methodsFor: 'initialization' stamp: 'lr 10/1/2010 14:37'!
fillOutDefinition: aDictionary
	className := (aDictionary at: '`#traitName') asSymbol.
	category := (aDictionary at: '`#category' ifAbsent: [ #Unclassified ]) asSymbol! !

!RBRefactoryDefinitionChange class methodsFor: 'instance creation' stamp: 'lr 9/30/2010 14:01'!
definition: aString
	^ self definition: aString for: nil! !

!RBRefactoryDefinitionChange class methodsFor: 'instance creation' stamp: 'lr 9/8/2011 20:10'!
definition: aString for: aController
	| parseTree context |
	parseTree := RBParser
		parseExpression: aString
		onError: [ :err :pos | ^ self error: 'Invalid definition string' ].
	context := RBSmallDictionary new.
	RBRefactoryDefinitionChange allSubclassesDo: [ :class |
		class definitionPatterns do: [ :pattern |
			((RBParser parseRewriteExpression: pattern) match: parseTree inContext: context empty)
			 	ifTrue: [ ^ class definition: aString for: aController context: context ] ] ].
	^ self error: 'Invalid definition string'! !

!RBRefactoryDefinitionChange class methodsFor: 'private' stamp: 'lr 9/30/2010 18:54'!
definition: aString for: aController context: aDictionary
	| dictionary |
	dictionary := RBSmallDictionary new.
	aDictionary keysAndValuesDo: [ :key :node |
		dictionary at: key formattedCode put: (node isVariable
			ifTrue: [ node name ]
			ifFalse: [ 
				node isLiteral
					ifTrue: [ node value ]
					ifFalse: [ node ] ]) ].
	^ self new
		definition: aString controller: aController;
		fillOutDefinition: dictionary;
		yourself! !

!RBRefactoryDefinitionChange class methodsFor: 'private' stamp: 'lr 10/1/2010 14:32'!
definitionPatterns
	self subclassResponsibility! !

!RBRefactoryDefinitionChange methodsFor: 'comparing' stamp: 'lr 9/30/2010 14:07'!
= aDefinitionChange
	^ self class = aDefinitionChange class
		and: [ self definition = aDefinitionChange definition ]! !

!RBRefactoryDefinitionChange methodsFor: 'printing' stamp: 'lr 9/30/2010 14:12'!
changeString
	^ 'Define ' , self displayClassName! !

!RBRefactoryDefinitionChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 14:13'!
controller
	^ controller! !

!RBRefactoryDefinitionChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 14:09'!
definedClass
	^ definedClass! !

!RBRefactoryDefinitionChange methodsFor: 'accessing' stamp: 'lr 9/30/2010 14:08'!
definition
	^ definition! !

!RBRefactoryDefinitionChange methodsFor: 'initialization' stamp: 'lr 10/1/2010 14:37'!
definition: aString controller: aController
	isMeta := false.
	definition := aString.
	controller := aController! !

!RBRefactoryDefinitionChange methodsFor: 'private' stamp: 'lr 9/30/2010 14:20'!
definitionClass
	self subclassResponsibility! !

!RBRefactoryDefinitionChange methodsFor: 'initialization' stamp: 'lr 10/1/2010 14:32'!
fillOutDefinition: aDictionary
	self subclassResponsibility! !

!RBRefactoryDefinitionChange methodsFor: 'comparing' stamp: 'lr 9/30/2010 14:07'!
hash
	^ definition hash! !

!RBRefactoryDefinitionChange methodsFor: 'private' stamp: 'lr 9/30/2010 19:21'!
namesIn: aString
	| names scanner token |
	names := OrderedCollection new.
	scanner := RBScanner
		on: (ReadStream on: aString)
		errorBlock: [ :msg :pos | ^ names ].
	[ scanner atEnd ] whileFalse: [
		token := scanner next.
		token isIdentifier
			ifTrue: [ names add: token value ] ].
	^ names asArray! !

!RBRefactoryDefinitionChange methodsFor: 'private' stamp: 'lr 10/14/2010 20:50'!
primitiveExecute
	definedClass := self definitionClass compilerClass
		evaluate: self definition
		notifying: self controller
		logged: true! !

!RBRefactoryDefinitionChange methodsFor: 'printing' stamp: 'lr 9/30/2010 14:12'!
printOn: aStream 
	aStream
		nextPutAll: definition;
		nextPut: $!!! !

RBRefactoryClassChange subclass: #RBRefactoryVariableChange
	instanceVariableNames: 'variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

RBRefactoryVariableChange subclass: #RBAddClassVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddClassVariableChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	^ RBRemoveClassVariableChange remove: self variable from: self changeClass! !

!RBAddClassVariableChange methodsFor: 'accessing' stamp: 'lr 10/15/2010 08:31'!
changeClass: aBehavior
	super changeClass: aBehavior.
	isMeta := false! !

!RBAddClassVariableChange methodsFor: 'printing' stamp: 'lr 10/15/2010 09:37'!
changeString
	^ 'Add class variable <1s> to <2s>' 
		expandMacrosWith: self variable
		with: self displayClassName! !

!RBAddClassVariableChange methodsFor: 'private' stamp: 'lr 3/20/2011 11:27'!
changeSymbol
	^ #addClassVarNamed:! !

RBRefactoryVariableChange subclass: #RBAddInstanceVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddInstanceVariableChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	^ RBRemoveInstanceVariableChange remove: self variable from: self changeClass! !

!RBAddInstanceVariableChange methodsFor: 'printing' stamp: 'lr 10/14/2010 20:52'!
changeString
	^ 'Add instance variable <1s> to <2s>'
		expandMacrosWith: self variable
		with: self displayClassName! !

!RBAddInstanceVariableChange methodsFor: 'private' stamp: 'lr 3/20/2011 11:26'!
changeSymbol
	^ #addInstVarNamed:! !

RBRefactoryVariableChange subclass: #RBAddPoolVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBAddPoolVariableChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	^ RBRemovePoolVariableChange remove: self variable from: self changeClass! !

!RBAddPoolVariableChange methodsFor: 'accessing' stamp: 'lr 10/15/2010 08:31'!
changeClass: aBehavior
	super changeClass: aBehavior.
	isMeta := false! !

!RBAddPoolVariableChange methodsFor: 'printing' stamp: 'lr 4/7/2010 08:19'!
changeString
	^ 'Add pool variable <1s> to <2s>' 
		expandMacrosWith: self variable
		with: self displayClassName! !

!RBAddPoolVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 21:30'!
changeSymbol
	^ #addSharedPool:! !

!RBRefactoryVariableChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:44'!
add: aVariable to: aBehavior
	"This should only be called on the Add*Change subclasses, but is here so we don't need to copy it to all subclasses"

	^ self new class: aBehavior variable: aVariable! !

!RBRefactoryVariableChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:44'!
remove: aVariable from: aBehavior
	"This should only be called on the Remove*Change subclasses, but is here so we don't need to copy it to all subclasses"

	^ self new class: aBehavior variable: aVariable! !

!RBRefactoryVariableChange methodsFor: 'comparing' stamp: 'lr 10/15/2010 09:37'!
= aRefactoryVariableChange
	^ super = aRefactoryVariableChange and: [ self variable = aRefactoryVariableChange variable ]! !

!RBRefactoryVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 21:27'!
changeObject
	^ self variable! !

!RBRefactoryVariableChange methodsFor: 'private' stamp: ''!
changeSymbol
	self subclassResponsibility! !

!RBRefactoryVariableChange methodsFor: 'initialize-release' stamp: ''!
class: aBehavior variable: aString 
	self changeClass: aBehavior.
	variable := aString! !

!RBRefactoryVariableChange methodsFor: 'comparing' stamp: 'lr 10/15/2010 09:37'!
hash
	^ self changeClassName hash bitXor: self variable hash! !

!RBRefactoryVariableChange methodsFor: 'private' stamp: 'lr 10/15/2010 09:43'!
primitiveExecute
	self changeClass perform: self changeSymbol with: self changeObject! !

!RBRefactoryVariableChange methodsFor: 'printing' stamp: 'lr 5/18/2010 20:48'!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName; nextPut: $ ;
		nextPutAll: self changeSymbol; nextPut: $ ;
		print: self variable;
		nextPut: $!!! !

!RBRefactoryVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 21:29'!
variable
	^ variable! !

RBRefactoryVariableChange subclass: #RBRemoveClassVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRemoveClassVariableChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	^ RBAddClassVariableChange add: self variable to: self changeClass! !

!RBRemoveClassVariableChange methodsFor: 'accessing' stamp: 'lr 10/15/2010 08:31'!
changeClass: aBehavior
	super changeClass: aBehavior.
	isMeta := false! !

!RBRemoveClassVariableChange methodsFor: 'printing' stamp: 'lr 10/15/2010 09:37'!
changeString
	^ 'Remove class variable <1s> from <2s>' 
		expandMacrosWith: self variable
		with: self displayClassName! !

!RBRemoveClassVariableChange methodsFor: 'private' stamp: 'lr 3/20/2011 11:28'!
changeSymbol
	^ #removeClassVarNamed:! !

RBRefactoryVariableChange subclass: #RBRemoveInstanceVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRemoveInstanceVariableChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	^ RBAddInstanceVariableChange add: self variable to: self changeClass! !

!RBRemoveInstanceVariableChange methodsFor: 'printing' stamp: 'lr 10/14/2010 20:53'!
changeString
	^ 'Remove instance variable <1s> from <2s>' 
		expandMacrosWith: self variable
		with: self displayClassName! !

!RBRemoveInstanceVariableChange methodsFor: 'private' stamp: 'lr 3/20/2011 11:27'!
changeSymbol
	^ #removeInstVarNamed:! !

RBRefactoryVariableChange subclass: #RBRemovePoolVariableChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRemovePoolVariableChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	^ RBAddPoolVariableChange add: self variable to: self changeClass! !

!RBRemovePoolVariableChange methodsFor: 'accessing' stamp: 'lr 10/15/2010 08:31'!
changeClass: aBehavior
	super changeClass: aBehavior.
	isMeta := false! !

!RBRemovePoolVariableChange methodsFor: 'printing' stamp: 'lr 4/7/2010 08:20'!
changeString
	^ 'Remove pool variable <1s> from <2s>' 
		expandMacrosWith: self variable
		with: self displayClassName! !

!RBRemovePoolVariableChange methodsFor: 'private' stamp: 'lr 9/6/2010 21:31'!
changeSymbol
	^ #removeSharedPool:! !

RBRefactoryClassChange subclass: #RBRemoveClassChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRemoveClassChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:44'!
remove: aClass
	^ self new changeClass: aClass! !

!RBRemoveClassChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:45'!
removeClassName: aSymbol
	^ self new changeClassName: aSymbol! !

!RBRemoveClassChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	| classChanges |
	classChanges := RBCompositeRefactoryChange new.
	self changeClass withAllSubclasses do: [ :each | 
		classChanges defineClass: each definition.
		each class instVarNames 
			do: [ :varName | classChanges addInstanceVariable: varName to: each class ].
		each selectors 
			do: [ :selector | classChanges compile: (each sourceCodeAt: selector) in: each ].
		each class selectors 
			do: [ :selector | classChanges compile: (each class sourceCodeAt: selector) in: each class ] ].
	^ classChanges! !

!RBRemoveClassChange methodsFor: 'accessing' stamp: 'lr 10/15/2010 09:10'!
changeClass: aBehavior
	super changeClass: aBehavior.
	isMeta := false! !

!RBRemoveClassChange methodsFor: 'printing' stamp: 'lr 4/7/2010 08:20'!
changeString
	^ 'Remove ' , self displayClassName! !

!RBRemoveClassChange methodsFor: 'private' stamp: ''!
primitiveExecute
	self changeClass removeFromSystem! !

!RBRemoveClassChange methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeFromSystem';
		nextPut: $!!! !

RBRefactoryClassChange subclass: #RBRemoveMethodChange
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRemoveMethodChange class methodsFor: 'instance creation' stamp: 'lr 9/7/2010 19:45'!
remove: aSymbol from: aClass
	^ self new
		changeClass: aClass;
		selector: aSymbol;
		yourself! !

!RBRemoveMethodChange methodsFor: 'comparing' stamp: 'lr 9/7/2010 19:10'!
= aRemoveMethodChange
	super = aRemoveMethodChange
		ifFalse: [ ^ false ].
	^ selector = aRemoveMethodChange selector! !

!RBRemoveMethodChange methodsFor: 'converting' stamp: 'lr 9/8/2011 20:10'!
asUndoOperation
	^ RBAddMethodChange compile: (self methodSourceFor: selector) in: self changeClass! !

!RBRemoveMethodChange methodsFor: 'printing' stamp: 'lr 4/7/2010 08:21'!
changeString
	^ 'Remove <1s>>>#<2s>'
		expandMacrosWith: self displayClassName
		with: selector! !

!RBRemoveMethodChange methodsFor: 'comparing' stamp: 'lr 9/7/2010 19:11'!
hash
	^ selector hash! !

!RBRemoveMethodChange methodsFor: 'private' stamp: 'lr 9/7/2010 19:11'!
primitiveExecute
	^ self changeClass removeSelector: selector! !

!RBRemoveMethodChange methodsFor: 'printing' stamp: 'lr 2/8/2008 09:29'!
printOn: aStream 
	aStream
		nextPutAll: self displayClassName;
		nextPutAll: ' removeSelector: ';
		print: self selector;
		nextPut: $!!! !

!RBRemoveMethodChange methodsFor: 'private' stamp: 'lr 9/7/2010 19:11'!
selector
	^ selector! !

!RBRemoveMethodChange methodsFor: 'initialize-release' stamp: 'lr 9/7/2010 19:11'!
selector: aSymbol
	selector := aSymbol! !

Object subclass: #RBRefactoryChangeManager
	instanceVariableNames: 'undo redo isPerformingRefactoring'
	classVariableNames: 'Instance UndoSize'
	poolDictionaries: ''
	category: 'Refactoring-Changes'!

!RBRefactoryChangeManager class methodsFor: 'class initialization' stamp: 'lr 4/4/2010 08:32'!
initialize
	self nuke.
	UndoSize := 20! !

!RBRefactoryChangeManager class methodsFor: 'instance creation' stamp: 'lr 4/4/2010 08:35'!
instance
	^ Instance ifNil: [ Instance := self basicNew initialize ]! !

!RBRefactoryChangeManager class methodsFor: 'instance creation' stamp: 'lr 4/4/2010 08:33'!
new
	^ self shouldNotImplement! !

!RBRefactoryChangeManager class methodsFor: 'public' stamp: 'lr 4/4/2010 08:34'!
nuke
	Instance notNil ifTrue: [ Instance release ].
	Instance := nil! !

!RBRefactoryChangeManager class methodsFor: 'settings' stamp: 'LukasRenggli 12/18/2009 10:42'!
settingsOn: aBuilder
	<systemsettings>
	
	(aBuilder setting: #undoSize)
		target: self;
		label: 'Undo size';
		parentName: #refactoring! !

!RBRefactoryChangeManager class methodsFor: 'class initialization' stamp: 'lr 4/4/2010 08:33'!
undoSize
	^ UndoSize! !

!RBRefactoryChangeManager class methodsFor: 'class initialization' stamp: ''!
undoSize: anInteger 
	UndoSize := anInteger max: 0! !

!RBRefactoryChangeManager class methodsFor: 'public' stamp: 'lr 4/4/2010 08:34'!
unload
	self nuke! !

!RBRefactoryChangeManager methodsFor: 'public access' stamp: 'lr 9/7/2010 19:11'!
addUndo: aRefactoringChange
	undo addLast: aRefactoringChange.
	undo size > UndoSize
		ifTrue: [ undo removeFirst ].
	redo := OrderedCollection new! !

!RBRefactoryChangeManager methodsFor: 'private' stamp: ''!
clearUndoRedoList
	undo := OrderedCollection new.
	redo := OrderedCollection new! !

!RBRefactoryChangeManager methodsFor: 'initialize-release' stamp: 'GuillermoPolito 7/2/2012 11:51'!
connectToChanges
	SystemAnnouncer announcer weak
		on: CategoryAdded,
			CategoryRemoved,
			CategoryRenamed,
			ClassAdded,
			ClassModifiedClassDefinition,
			ClassRemoved,
			ClassRenamed,
			ClassReorganized,
			MethodAdded,
			MethodModified,
			MethodRemoved,
			ProtocolAdded,
			ProtocolRemoved
		send: #update:
		to: self.! !

!RBRefactoryChangeManager methodsFor: 'initialize-release' stamp: 'CamilleTeruel 7/29/2012 18:46'!
disconnectFromChanges
	SystemAnnouncer uniqueInstance unsubscribe: self! !

!RBRefactoryChangeManager methodsFor: 'testing' stamp: 'lr 9/7/2010 19:11'!
hasRedoableOperations
	^ redo isEmpty not! !

!RBRefactoryChangeManager methodsFor: 'testing' stamp: 'lr 9/7/2010 19:11'!
hasUndoableOperations
	^ undo isEmpty not! !

!RBRefactoryChangeManager methodsFor: 'public access' stamp: 'lr 9/7/2010 19:11'!
ignoreChangesWhile: aBlock
	isPerformingRefactoring
		ifTrue: [ ^ aBlock value ].
	isPerformingRefactoring := true.
	aBlock ensure: [ isPerformingRefactoring := false ]! !

!RBRefactoryChangeManager methodsFor: 'initialize-release' stamp: ''!
initialize
	undo := OrderedCollection new.
	redo := OrderedCollection new.
	isPerformingRefactoring := false.
	self connectToChanges! !

!RBRefactoryChangeManager methodsFor: 'public access' stamp: 'lr 9/7/2010 19:11'!
performChange: aRefactoringChange
	self ignoreChangesWhile: [ self addUndo: aRefactoringChange execute ]! !

!RBRefactoryChangeManager methodsFor: 'public access' stamp: 'lr 9/7/2010 19:11'!
redoChange
	^ redo last! !

!RBRefactoryChangeManager methodsFor: 'public access' stamp: 'lr 9/7/2010 19:12'!
redoOperation
	redo isEmpty
		ifTrue: [ ^ self ].
	self ignoreChangesWhile: [ 
		| change |
		change := redo removeLast.
		undo add: change execute ]! !

!RBRefactoryChangeManager methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	self disconnectFromChanges! !

!RBRefactoryChangeManager methodsFor: 'public access' stamp: 'lr 9/7/2010 19:12'!
undoChange
	^ undo last! !

!RBRefactoryChangeManager methodsFor: 'public access' stamp: 'lr 9/7/2010 19:12'!
undoOperation
	undo isEmpty
		ifTrue: [ ^ self ].
	self ignoreChangesWhile: [ 
		| change |
		change := undo removeLast.
		redo add: change execute ]! !

!RBRefactoryChangeManager methodsFor: 'updating' stamp: 'GuillermoPolito 7/2/2012 11:54'!
update: anEvent
	isPerformingRefactoring
		ifFalse: [ self clearUndoRedoList ]! !

Object subclass: #TestRunner
	instanceVariableNames: 'categories categoriesSelected classes classIndex classesSelected failedList failedSelected errorList errorSelected lastUpdate result previousRun categoryPattern classPattern testAnnouncementBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-UI'!

!TestRunner commentStamp: '<historical>' prior: 0!
<lint: #ignore rule: #classNotReferenced rational: 'this view is only accessed from menus'>

!

!TestRunner class methodsFor: 'instance-creation' stamp: 'zork 6/5/2011 12:31'!
open
	^ self new open! !

!TestRunner class methodsFor: 'window color' stamp: 'AlainPlantec 12/16/2009 22:10'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color brown whiter! !

!TestRunner class methodsFor: 'initialization' stamp: 'BartGauquie 11/1/2009 10:52'!
registerAsDefaultTestRunner
	TestRunnerBrowser default: self.! !

!TestRunner methodsFor: 'actions' stamp: 'nice 10/20/2009 21:08'!
addDeclaredPackagesUnderTestTo: packages 
	classesSelected do: 
		[ :class | 
		(class class includesSelector: #packageNamesUnderTest) ifTrue: 
			[ class packageNamesUnderTest do: [ :name | packages add: (PackageInfo named: name) ] ] ]! !

!TestRunner methodsFor: 'actions' stamp: 'StephaneDucasse 8/9/2011 17:51'!
addMethodsUnderTestIn: packages to: methods 
	packages
		do: [:package | package isNil
				ifFalse: [package methods
						do: [:method | ((#(#packageNamesUnderTest #classNamesNotUnderTest ) includes: method selector)
									or: [method compiledMethod isAbstract
											or: [method compiledMethod refersToLiteral: #ignoreForCoverage]])
								ifFalse: [methods add: method]]]]! !

!TestRunner methodsFor: 'accessing' stamp: 'CarloTeixeira 10/24/2011 22:26'!
allSelectedTestSuites
	"Return the suite for all the selected test case classes"
	
	^ classesSelected select: [ :each | each isAbstract not] thenCollect: [:each | each suite].! !

!TestRunner methodsFor: 'factory' stamp: 'lr 10/31/2005 15:31'!
baseClass
	^ TestCase! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'BenjaminVanRyseghem 2/8/2012 17:09'!
browseClass

	^ (classes at: classIndex ifAbsent: [ ^ self ]) browse! !

!TestRunner methodsFor: 'browsing' stamp: 'BenjaminVanRyseghem 1/13/2011 11:31'!
browseSelectedErrorTest

	errorSelected ifNil: [^self].
	self browseSelectedTest: errorSelected! !

!TestRunner methodsFor: 'browsing' stamp: 'BenjaminVanRyseghem 1/13/2011 11:28'!
browseSelectedFailedTest

	failedSelected ifNil: [^self].
	self browseSelectedTest: failedSelected! !

!TestRunner methodsFor: 'browsing' stamp: 'IgorStasenko 4/26/2011 16:21'!
browseSelectedTest: aTest

	Smalltalk tools browser fullOnClass: aTest class selector: aTest selector! !

!TestRunner methodsFor: 'private' stamp: 'lr 3/14/2010 21:13'!
browserEnvironment
	^ Smalltalk globals classNamed: #BrowserEnvironment! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:07'!
build
	"self new build openInWorld"
	
	| window |
	window := (SystemWindow labelled: self label) model: self; extent: self extent.
	
	window addMorph: self buildCategorySearch fullFrame: self categorySearchFrame.
	window addMorph: self buildCategories fullFrame: self categoriesFrame.
	
	window addMorph: self buildClassesSearch fullFrame: self classesSearchFrame.
	window addMorph: self buildClasses fullFrame: self classesFrame.
	
	window	addMorph: self buildStatus fullFrame: self statusFrame. 
	window	addMorph: self buildFailures fullFrame: self failureListFrame. 
	window	addMorph: self buildErrors fullFrame: self errorListFrame. 
	window	addMorph: self buildButtons fullFrame: self buttonsFrame. 
	^ window
	
	
	! !

!TestRunner methodsFor: 'building' stamp: 'md 7/28/2011 13:22'!
buildButtons
	^ PluggablePanelMorph newRow
		model: self;
		layoutInset: 0;
		color: Color transparent;
		addAllMorphs: (self buttons collect: [ :each |
			PluggableButtonMorph new
				on: self
				getState: nil
				action: each second
				label: nil
				menu: nil;
				label: each first;
				setBalloonText: each third;
				getEnabledSelector: (each at: 4);
				hResizing: #spaceFill;
				yourself ]);
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 9/5/2011 18:23'!
buildCategories

	^ PluggableListMorph new
		on: self
		list: #categoryList 
		primarySelection: #categorySelected 
		changePrimarySelection: #categorySelected: 
		listSelection: #categoryAt: 
		changeListSelection: #categoryAt:put: 
		menu: #categoryMenu:  
		keystroke: nil;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:06'!
buildCategorySearch

	^ SearchMorph new
		model: self;
		updateSelector: #categorySearchUpdate:;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 9/5/2011 18:23'!
buildClasses

	^ PluggableListMorph new
		on: self
		list: #classList 
		primarySelection: #classSelected 
		changePrimarySelection: #classSelected: 
		listSelection: #classAt: 
		changeListSelection: #classAt:put: 
		menu: #classMenu:  
		keystroke: nil;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:06'!
buildClassesSearch
	
	^ SearchMorph new
		model: self;
		updateSelector: #classSearchUpdate:;
		yourself! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 6/6/2011 20:38'!
buildErrors
	^ PluggableListMorph new
			on: self 
			list: #errorList
			selected: #errorSelected
			changeSelected: #errorSelected:
			menu: #errorMenu: 
			keystroke: nil.
	! !

!TestRunner methodsFor: 'building' stamp: 'MarcusDenker 6/10/2011 14:11'!
buildFailures
	^ PluggableListMorph new
			on: self 
			list: #failedList
			selected: #failedSelected
			changeSelected: #failedSelected:
			menu: #failureMenu: 
			keystroke: nil.
	
		" do not know how to express
		name: 'Failure List'"! !

!TestRunner methodsFor: 'newbuilding' stamp: 'StephaneDucasse 6/5/2011 15:21'!
buildStatus

	^ (PluggableTextFieldMorph
		on: self 
		text: #statusText 
		accept: nil 
		readSelection: nil 
		menu: #statusMenu:)
			getColorSelector: #statusColor ; yourself.
	! !

!TestRunner methodsFor: 'building' stamp: 'lr 7/27/2011 23:05'!
buttonHeight
	^ self theme buttonMinHeight + 4! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'tbn 7/29/2010 21:17'!
buttons
	^ #(( 'Run Selected' #runAll 'Run all selected tests' #hasRunnable )
		( 'Run Profiled' #runProfiled 'Run tests and profile' #hasRunnable )
		( 'Run Coverage' #runCoverage 'Run test and check code coverage' #hasRunnable )
		( 'Run Failures' #runFailures 'Run all failures' #hasFailures )
		( 'Run Errors' #runErrors 'Run all errors' #hasErrors )
		( 'File out results' #fileOutResults 'File out test results' #hasFailuresOrErrors))! !

!TestRunner methodsFor: 'building' stamp: 'zork 6/5/2011 12:39'!
buttonsFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 1 offset: self buttonHeight negated;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: 0! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 01:55'!
categoriesFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: (UITheme current textFont height + 13);
		rightFraction: 0.25 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:09'!
categoryAt: anIndex
	^ categoriesSelected includes: (categories at: anIndex ifAbsent: [ ^ false ]).! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:51'!
categoryAt: anInteger put: aBoolean
	categoriesSelected := categoriesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (categories at: anInteger ifAbsent: [ ^ self ]).
	self changed: #categorySelected; updateClasses.! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'CamilloBruni 8/16/2011 02:03'!
categoryList
	^ categories! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 11/1/2005 19:25'!
categoryMenu: aMenu
	^ aMenu
		title: 'Categories';
		add: 'Select all' action: #selectAllCategories;
		add: 'Select inversion' action: #selectInverseCategories;
		add: 'Select none' action: #selectNoCategories;
		addLine;
		add: 'Filter...' action: #filterCategories;
		addLine;
		add: 'Refresh' action: #updateCategories;
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 02:06'!
categorySearchFrame
	^LayoutFrame new
		leftFraction: 0 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.25 offset: 0;
		bottomFraction: 0 offset: (UITheme current textFont height + 10)! !

!TestRunner methodsFor: 'building' stamp: 'MarianoMartinezPeck 12/16/2011 11:04'!
categorySearchUpdate: aPattern
	categoryPattern := (aPattern isNil or: [ aPattern trimBoth isEmpty ])
		ifTrue: [ nil ]
		ifFalse: [ aPattern asRegexIgnoringCase ].
	self updateCategories.! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:11'!
categorySelected
	^ 0! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 10/31/2005 15:12'!
categorySelected: anInteger
	self changed: #categorySelected.! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 10/8/2005 19:58'!
classAt: anInteger
	^ classesSelected includes: (classes at: anInteger ifAbsent: [ ^ false ]).! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 11/21/2005 13:19'!
classAt: anInteger put: aBoolean
	classesSelected := classesSelected
		perform: (aBoolean ifTrue: [ #copyWith: ] ifFalse: [ #copyWithout: ])
		with: (classes at: anInteger ifAbsent: [ ^ self ]).
	self changed: #classSelected; changed: #hasRunnable.! !

!TestRunner methodsFor: 'factory' stamp: 'StephaneDucasse 6/9/2012 23:05'!
classForTestSuite
	^ TestSuite! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'nice 1/5/2010 15:59'!
classList
	| offset |
	classes isEmpty ifTrue: [ ^ classes ].
	offset := classes first allSuperclasses size.
	^ classes collect: [ :each | | ident |
		ident := String 
			new: 2 * (0 max: each allSuperclasses size - offset) 
			withAll: $ .
		each isAbstract
			ifFalse: [ ident , each name ]
			ifTrue: [ 
				ident asText , each name asText 
					addAttribute: TextEmphasis italic;
					yourself ] ].! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'StephaneDucasse 5/15/2011 22:42'!
classMenu: aMenu
	^ aMenu
		title: 'Classes';
		add: 'Browse' action: #browseClass;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select unit tests' action: #selectAllUnitTests;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		add: 'Refresh' action: #updateClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Run selected' action: #runAll;
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'MarianoMartinezPeck 12/16/2011 11:04'!
classSearchUpdate: aPattern
	classPattern := (aPattern isNil or: [ aPattern trimBoth isEmpty ])
		ifTrue: [ nil ]
		ifFalse: [ aPattern asRegexIgnoringCase ].
	self updateClasses.! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:46'!
classSelected
	^ classIndex! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:48'!
classSelected: anInteger
	classIndex := anInteger.
	self changed: #classSelected! !

!TestRunner methodsFor: 'building' stamp: 'CamilloBruni 8/16/2011 01:55'!
classesFrame
	^LayoutFrame new
		leftFraction: 0.25 offset: 0;
		topFraction: 0 offset: (UITheme current textFont height + 13);
		rightFraction: 0.5 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated! !

!TestRunner methodsFor: 'building' stamp: 'StephaneDucasse 9/5/2011 18:37'!
classesSearchFrame
	^LayoutFrame new
		leftFraction: 0.25 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 0.5 offset: 0;
		bottomFraction: 0 offset: (StandardFonts defaultFont height + 10)! !

!TestRunner methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/1/2011 07:44'!
collectCoverageFor: methods
	| wrappers suite |
	wrappers := methods collect: [ :each | TestCoverage on: each ].
	suite := self
		resetResult;
		suiteForAllSelected.
	
	[ wrappers do: [ :each | each install ].
	[ self runSuite: suite ] ensure: [ wrappers do: [ :each | each uninstall ] ] ] valueUnpreemptively.
	wrappers := wrappers reject: [ :each | each hasRun ].
	wrappers isEmpty 
		ifTrue: 
			[ UIManager default inform: 'Congratulations. Your tests cover all code under analysis.' ]
		ifFalse: 
			[ 
			| ml |
			ml := MessageList new.
			(wrappers collect: [ :each | ml addMethodReference: each reference ]).
			(Smalltalk tools messageList 
				on: ml
				named: 'Not Covered Code (' , (100 - (100 * wrappers size // methods size)) printString , '% Code Coverage)') open ].
	self saveResultInHistory! !

!TestRunner methodsFor: 'actions' stamp: 'StephaneDucasse 6/9/2012 23:10'!
debug: aTestCase
	self
		debugSuite:
			(self classForTestSuite new
				addTest: aTestCase;
				yourself)! !

!TestRunner methodsFor: 'actions' stamp: 'SantiagoBragagnolo 4/29/2012 20:25'!
debugSuite: aTestSuite
	self executeSuite: aTestSuite as: [ :aSuite | aSuite debug ].! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:37'!
errorList
	^ errorList collect: [ :each | each printString ].! !

!TestRunner methodsFor: 'building' stamp: 'lr 7/27/2011 23:00'!
errorListFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0.5 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 1 offset: self buttonHeight negated! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'BenjaminVanRyseghem 1/13/2011 11:35'!
errorMenu: aMenu
	"Add the browse item only if an item is selected"

	self statusMenu: aMenu.
	errorSelected ifNotNil: [aMenu add: 'Browse test' action: #browseSelectedErrorTest].
	^aMenu! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 19:46'!
errorSelected
	^ errorList indexOf: errorSelected.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/27/2005 10:37'!
errorSelected: anInteger
	errorSelected := errorList at: anInteger ifAbsent: nil.
	self changed: #errorSelected.
	errorSelected ifNotNil: [ self debug: errorSelected ].! !

!TestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 6/9/2012 23:05'!
errorTestSuites
	^ errorList
		collect: [ :each | 
			self classForTestSuite new
				in: [ :suite | 
							suite
								addTest: each;
								name: (self label: 'Error' forSuite: suite) ];
				yourself ]! !

!TestRunner methodsFor: 'actions' stamp: 'lr 3/14/2010 21:13'!
excludeClassesNotUnderTestFrom: methods
	classesSelected
		do: [ :class | 
			(class class includesSelector: #classNamesNotUnderTest)
				ifTrue: [ 
					class classNamesNotUnderTest
						do: [ :className | 
							| theClass |
							theClass := Smalltalk globals classNamed: className.
							theClass
								ifNotNil: [ 
									theClass methods do: [ :each | methods remove: each methodReference ifAbsent: [  ] ].
									theClass class methods do: [ :each | methods remove: each methodReference ifAbsent: [  ] ] ] ] ] ]! !

!TestRunner methodsFor: 'processing' stamp: 'SantiagoBragagnolo 4/30/2012 14:25'!
executeSuite: aTestSuite as: aBlock
" The block defines how to interact with the suite. run with a result or debug "
	aTestSuite subscribe:TestAnnouncement do: self updateUIBlock.
	[ aBlock cull: aTestSuite cull: result  ] ensure: [
		aTestSuite unsubscribe:TestAnnouncement.
	].


! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'lr 10/8/2005 18:39'!
extent
	^ 640 @ 480! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:37'!
failedList
	^ failedList collect: [ :each | each printString ].! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 19:47'!
failedSelected
	^ failedList indexOf: failedSelected.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 20:14'!
failedSelected: anInteger
	failedSelected := failedList at: anInteger ifAbsent: nil.
	self changed: #failedSelected.
	failedSelected ifNotNil: [ self debug: failedSelected ].! !

!TestRunner methodsFor: 'building' stamp: 'bp 11/22/2010 20:43'!
failureListFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0 offset: self statusHeight;
		rightFraction: 1 offset: 0;
		bottomFraction: 0.5 offset: 0! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'BenjaminVanRyseghem 1/13/2011 11:35'!
failureMenu: aMenu
	"Add the browse item only if an item is selected"
	
	failedSelected ifNotNil: [aMenu add: 'Browse test' action: #browseSelectedFailedTest].
	^ aMenu! !

!TestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 6/9/2012 23:05'!
failureTestSuites
	^ failedList
		collect: [ :each | 
			self classForTestSuite new
				in: [ :suite | 
							suite
								addTest: each;
								name: (self label: 'Failure' forSuite: suite) ];
				yourself ]! !

!TestRunner methodsFor: 'actions' stamp: 'MarcusDenker 5/1/2011 14:03'!
fileOutResults
	| fileName defaultFilename stream printer |
	"Save current test results into text file."
	"Generate a filename like 'tests_Pharo-1.1-11367-Beta_23_May_2010_9:19:20_am.txt' "
	defaultFilename := 	'tests_',
						SystemVersion current version, 
						'_', 
						(result timeStamp asString copyReplaceAll: ' ' with: '_'),
						'.txt'.
	fileName := UIManager default 
		request: 'Enter the file name' 
		initialAnswer: defaultFilename.
	
	stream := MultiByteFileStream newFileNamed: fileName.	
	[result fileOutOn: stream] 
		ensure: [stream close].! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
filterCategories
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select categories:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	categoriesSelected := (categories 
		select: [ :each | pattern match: each ]) asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 7/4/2009 15:10'!
filterClasses
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select tests:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	classesSelected := (classes select: [ :each | 
		pattern match: each name ]) asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'utilities' stamp: 'CamilloBruni 8/16/2011 02:05'!
findCategories
	| visible |
	visible := Set new.
	self baseClass withAllSubclassesDo: [ :each |
		each category ifNotNil: [ :category |
			visible add: category ] ].
	^ Array streamContents: [ :stream |
		Smalltalk organization categories do: [ :each |
			((visible includes: each) 
					and: [ categoryPattern isNil or: [ (categoryPattern matchesIn: each) isEmpty not]])
				ifTrue: [ stream nextPut: each ] ] ].! !

!TestRunner methodsFor: 'utilities' stamp: 'CamilloBruni 8/16/2011 02:11'!
findClassesForCategories: aCollection
	| items |
	aCollection isEmpty
		ifTrue: [ ^ self baseClass withAllSubclasses asSet ].
	items := aCollection
		gather: [ :category | 
			((Smalltalk organization listAtCategoryNamed: category) 
				collect: [ :each | Smalltalk globals at: each ])
				select: [ :each | each includesBehavior: self baseClass ] ].

	^ items asSet! !

!TestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasErrors
	^ result hasErrors.! !

!TestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasFailures
	^ result hasFailures.! !

!TestRunner methodsFor: 'testing' stamp: 'LaurentLaffont 5/23/2010 08:19'!
hasFailuresOrErrors
	^ result hasFailures | result hasErrors.! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 20:28'!
hasProgress

	result classesTested do: [:cls |
		(cls class methodDictionary includesKey: #lastStoredRun)
			ifTrue: [^ true]].
	^ false! !

!TestRunner methodsFor: 'history saving' stamp: 'GwenaelCasaccio 10/1/2008 22:00'!
hasResults

	^ result notNil! !

!TestRunner methodsFor: 'testing' stamp: 'lr 11/21/2005 13:19'!
hasRunnable
	^ classesSelected notEmpty.! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 12:00'!
historyMenuList
	^ {'** save current result **'}, (self previousRun collect: [:ts | ts printString])! !

!TestRunner methodsFor: 'initialization' stamp: 'StephaneDucasse 6/14/2012 16:19'!
initialize
	super initialize.
	failedList := errorList := Array new.
	SystemAnnouncer current
		weak
		on: ClassAdded, CategoryAdded, ClassRemoved, CategoryRemoved, ClassRenamed, CategoryRenamed, ClassRecategorized send: #update to: self.
	self update; resetResult! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'lr 1/20/2006 13:36'!
label
	^ 'Test Runner' ! !

!TestRunner methodsFor: 'private' stamp: 'lr 10/27/2005 10:32'!
label: aString forSuite: aTestSuite
	^ String streamContents: [ :stream |
		stream nextPutAll: 'Running '; print: aTestSuite tests size; space; nextPutAll: aString.
		aTestSuite tests size > 1 ifTrue: [ stream nextPut: $s ] ]. ! !

!TestRunner methodsFor: 'building' stamp: 'zork 6/5/2011 12:31'!
open

	^ self build openInWorld
	
! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 11:46'!
previousRun

	^ previousRun ifNil: [ previousRun := OrderedCollection new ]! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:11'!
promptForPackages
	| packages |
	packages := (PackageOrganizer default packages
				reject: [:package | (package packageName beginsWith: 'Kernel')
						or: [(package packageName beginsWith: 'Collections')
								or: [(package packageName beginsWith: 'Exceptions')
										or: [(package packageName beginsWith: 'SUnit')
												or: [(package packageName beginsWith: 'System')
														or: [package packageName includesSubstring: 'Test' caseSensitive: false]]]]]])
				sort: [:a :b | a packageName < b packageName].
	packages := Array
				with: (UIManager default
						chooseFrom: (packages
								collect: [:package | package packageName])
						values: packages
						title: 'Select Package').
	^ packages! !

!TestRunner methodsFor: 'actions' stamp: 'StephaneDucasse 6/9/2012 22:49'!
resetResult

	self result: TestAsserter classForTestResult new ; updateResults.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/6/2005 15:47'!
result
	^ result! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:47'!
result: aResult
	result := aResult! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:26'!
runAll

	self resetResult.
	self runTestSuites: self allSelectedTestSuites.
	self saveResultInHistory! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:15'!
runCoverage
	| packages methods |
	packages := Set new.
	self addDeclaredPackagesUnderTestTo: packages.
	packages isEmpty ifTrue: 
		[ packages := self promptForPackages ].
	methods := OrderedCollection new.
	self 
		addMethodsUnderTestIn: packages
		to: methods.
	self excludeClassesNotUnderTestFrom: methods.
	methods isEmpty ifTrue: 
		[ ^ UIManager default inform: 'No methods found for coverage analysis.' ].
	self collectCoverageFor: methods
! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:26'!
runErrors
	self result instVarNamed: 'errors' put: OrderedCollection new.
	self runTestSuites: self errorTestSuites.! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:26'!
runFailures
	self result instVarNamed: 'failures' put: Set new.
	self runTestSuites: self failureTestSuites.! !

!TestRunner methodsFor: 'actions' stamp: 'lr 10/31/2005 17:13'!
runProfiled
	MessageTally spyOn: [ self runAll ].! !

!TestRunner methodsFor: 'actions' stamp: 'SantiagoBragagnolo 4/29/2012 20:25'!
runSuite: aTestSuite
	self executeSuite: aTestSuite as: [ :aSuite :aResult | aSuite run: aResult ].
	self updateResults

! !

!TestRunner methodsFor: 'actions' stamp: 'lr 11/3/2005 09:15'!
runTest: aTestCase
	aTestCase run: result.
	self updateStatus: true.! !

!TestRunner methodsFor: 'actions' stamp: 'CarloTeixeira 10/24/2011 22:30'!
runTestSuites: testSuites 
	testSuites
		do: [:testSuite | self runSuite: testSuite]
		displayingProgress: 'Running Tests'! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 19:36'!
saveResultInHistory
	result dispatchResultsIntoHistory! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectAllCategories
	categoriesSelected := categories asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectAllClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'JorgeRessia 3/16/2010 20:24'!
selectAllUnitTests
	classesSelected := classes asSet select: [ :eachClass | eachClass isUnitTest ].
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectInverseCategories
	categoriesSelected := categories asSet 
		removeAll: categoriesSelected;
		yourself.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectInverseClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet 
		removeAll: classesSelected;
		yourself.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectNoCategories
	categoriesSelected := Set new.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 11:59'!
selectNoClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := Set new.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectSubclasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	| classesForPackages |
	classesForPackages := self findClassesForCategories: categoriesSelected.	
	classesSelected := (classesSelected gather: [ :class |
		class withAllSubclasses select: [ :each |
			classesForPackages includes: each ] ])
		asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'history saving' stamp: 'IgorStasenko 4/26/2011 16:21'!
showDiffWith: aTestResult
	| string diff |

	diff := result diff: aTestResult.
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result with: ', aTestResult asString; cr.
		str nextPutAll: 'New passed: '.
		diff first do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		diff second do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		diff third do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Smalltalk tools workspace new contents: string; openLabel: 'SUnit Progress'
	! !

!TestRunner methodsFor: 'history saving' stamp: 'stephane.ducasse 10/12/2008 19:24'!
showHistoryMenu
	| selectionIndex selectedPreviousResult actionIndex |
	selectionIndex := UIManager default chooseFrom: self historyMenuList title: 'History:'.

	"We pressed outside the menu"
	selectionIndex isZero ifTrue: [ ^ self ]. 				

	"save current result is selected"
	selectionIndex = 1 ifTrue: [ self previousRun addFirst: result. ^ self ]. 			

	selectedPreviousResult := self previousRun at: (selectionIndex - 1).
 	actionIndex := (UIManager default chooseFrom: #('delete' 'show diff')  title:  'Action:').
	actionIndex = 1 ifTrue: [ self previousRun remove: selectedPreviousResult. ^ self ].
	actionIndex = 2 ifTrue: [ self showDiffWith: selectedPreviousResult].	! !

!TestRunner methodsFor: 'history saving' stamp: 'MarcusDenker 5/27/2011 14:11'!
showProgress
	| testCaseClasses d string |
	testCaseClasses := (self suiteForAllSelected tests collect: [:testCase | testCase class]) asSet.
	
	"At the end of the algorithm, d will contains all the diff between what was saved and the current result"
	d := Dictionary new.
	d at: #passed put: OrderedCollection new.
	d at: #failures put: OrderedCollection new.
	d at: #errors put: OrderedCollection new.

	testCaseClasses do: [ :cls | | t |
		(cls class methodDict includesKey: #lastStoredRun)
			ifTrue: [t := cls lastStoredRun.
					(t at: #passed) do: [:s | 	
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]  ].
											
					(t at: #failures) do: [:s | (result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}]].
											
					(t at: #errors) do: [:s | 	(result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]]]].
		
			
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result and saved result'; cr.
		str nextPutAll: 'New passed: '.
		(d at: #passed) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		(d at: #failures) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		(d at: #errors) do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Smalltalk tools workspace new contents: string; openLabel: 'SUnit Progress' string.

	! !

!TestRunner methodsFor: 'utilities' stamp: 'lr 10/10/2005 08:43'!
sortClass: aFirstClass before: aSecondClass
	| first second |
	first := aFirstClass withAllSuperclasses reversed.
	second := aSecondClass withAllSuperclasses reversed.
	1 to: (first size min: second size) do: [ :index | 
		(first at: index) == (second at: index)
			ifFalse: [ ^ (first at: index) name <= (second at: index) name ] ].
	^ second includes: aFirstClass.! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 3/16/2010 19:37'!
statusColor
	result hasErrors 
		ifTrue: [ ^ Color red ].
	result hasFailures 
		ifTrue: [ ^ Color yellow ].
	^ Color green! !

!TestRunner methodsFor: 'building' stamp: 'bp 11/22/2010 20:41'!
statusFrame
	^LayoutFrame new
		leftFraction: 0.5 offset: 0;
		topFraction: 0 offset: 0;
		rightFraction: 1 offset: 0;
		bottomFraction: 0 offset: self statusHeight! !

!TestRunner methodsFor: 'building' stamp: 'lr 7/27/2011 23:01'!
statusHeight
	^ self theme textFont height * 4! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'simon.denier 11/13/2008 19:43'!
statusMenu: aMenu
	^ aMenu
		add: 'History' action: #showHistoryMenu;
		add: 'Store result as progress reference' action: #storeResultIntoTestCases;
		add: 'Show progress' action: #showProgress; 
		yourself! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'lr 10/8/2005 22:45'!
statusText
	^ result printString.! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 20:28'!
storeResultIntoTestCases

	result classesTested do: [:testCaseCls | testCaseCls generateLastStoredRunMethod ]
! !

!TestRunner methodsFor: 'accessing' stamp: 'StephaneDucasse 6/9/2012 23:05'!
suiteForAllSelected
	"Return the suite for all the selected test case classes"

	^ self classForTestSuite new
		in: [ :suite | 
			classesSelected
				do: [ :each | 
					each isAbstract
						ifFalse: [ each addToSuiteFromSelectors: suite ] ].
			suite name: (self label: 'Test' forSuite: suite) ]! !

!TestRunner methodsFor: 'theme' stamp: 'MarcusDenker 4/14/2011 13:14'!
theme
	"Answer the ui theme that provides controls."

	^UITheme current! !

!TestRunner methodsFor: 'updating' stamp: 'lr 3/22/2006 19:35'!
update
	self updateCategories; updateClasses! !

!TestRunner methodsFor: 'updating' stamp: 'lr 10/31/2005 15:45'!
updateCategories
	categories := self findCategories.
	categoriesSelected := categoriesSelected isNil
		ifTrue: [ Set new ]
		ifFalse: [
			categoriesSelected
				select: [ :each | categories includes: each ] ].
	self changed: #categoryList; changed: #categorySelected.! !

!TestRunner methodsFor: 'updating' stamp: 'CamilloBruni 8/16/2011 02:11'!
updateClasses
	| classesForCategories |
	classesForCategories := self findClassesForCategories: categoriesSelected.
	
	classPattern ifNotNil: [
		classesForCategories := classesForCategories reject: [:cls| (classPattern matchesIn: cls name) isEmpty ]].
	
	classes := classesForCategories asArray
		sort: [ :a :b | self sortClass: a before: b ].
	classIndex := 0.
	classesSelected := classesSelected isNil
		ifTrue: [ classesForCategories ]
		ifFalse: [ 
			classesSelected
				select: [ :each | classesForCategories includes: each ] ].
	self changed: #classList; 
		changed: #classSelected; 
		changed: #hasRunnable.! !

!TestRunner methodsFor: 'updating' stamp: 'LaurentLaffont 2/27/2011 17:20'!
updateResults
	"<lint: #expect rule: #guardingClause>"
	"<lint: #expect rule: #longMethods>"

	self updateStatus: false.
	failedList size = result failures size ifFalse: [
		failedList := result failures asArray
			sort: [ :a :b | a printString <= b printString ].
		failedSelected := nil.
		self 
			changed: #failedList; 
			changed: #failedSelected;
			changed: #hasFailures;
			changed: #hasProgress;
			changed: #hasFailuresOrErrors  ].
	errorList size = result errors size ifFalse: [
		errorList := result errors asArray
			sort: [ :a :b | a printString <= b printString ].
		errorSelected := nil.
		self 
			changed: #errorList; 
			changed: #errorSelected;
			changed: #hasErrors;
			changed: #hasProgress;
			changed: #hasFailuresOrErrors  ].! !

!TestRunner methodsFor: 'updating' stamp: 'lr 11/3/2005 09:28'!
updateStatus: aBoolean
	"Update the status display, at most once a second if aBoolean is true."

	(aBoolean and: [ lastUpdate = Time totalSeconds ])
		ifTrue: [ ^ self ].
	self changed: #statusText; changed: #statusColor.
	lastUpdate := Time totalSeconds.! !

!TestRunner methodsFor: 'updating' stamp: 'SeanDeNigris 6/21/2012 12:33'!
updateUIBlock
	^ testAnnouncementBlock ifNil: [
		testAnnouncementBlock :=  [ :announcement | self updateStatus: true ] ].! !

!TestRunner methodsFor: 'private' stamp: 'CamilleTeruel 7/29/2012 18:49'!
windowIsClosing
	SystemAnnouncer uniqueInstance unsubscribe: self! !
MCMockRPackage initialize!
RBRefactoryChangeManager initialize!
